# coding: utf-8

"""
    candidates-api

    The Candidate APIs allows you to add, update and delete candidates.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class AddOrUpdateEducationRequestEducation(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'degree': 'str',
        'field_of_study': 'str',
        'school_name': 'str',
        'start_month': 'int',
        'start_year': 'int',
        'end_month': 'int',
        'end_year': 'int',
        'is_high_education': 'bool',
        'city': 'str',
        'state': 'str',
        'country': 'str',
        'university_name': 'str'
    }

    attribute_map = {
        'degree': 'degree',
        'field_of_study': 'fieldOfStudy',
        'school_name': 'schoolName',
        'start_month': 'startMonth',
        'start_year': 'startYear',
        'end_month': 'endMonth',
        'end_year': 'endYear',
        'is_high_education': 'isHighEducation',
        'city': 'city',
        'state': 'state',
        'country': 'country',
        'university_name': 'universityName'
    }

    def __init__(self, degree=None, field_of_study=None, school_name=None, start_month=None, start_year=None, end_month=None, end_year=None, is_high_education=None, city=None, state=None, country=None, university_name=None):  # noqa: E501
        """AddOrUpdateEducationRequestEducation - a model defined in Swagger"""  # noqa: E501
        self._degree = None
        self._field_of_study = None
        self._school_name = None
        self._start_month = None
        self._start_year = None
        self._end_month = None
        self._end_year = None
        self._is_high_education = None
        self._city = None
        self._state = None
        self._country = None
        self._university_name = None
        self.discriminator = None
        if degree is not None:
            self.degree = degree
        if field_of_study is not None:
            self.field_of_study = field_of_study
        if school_name is not None:
            self.school_name = school_name
        if start_month is not None:
            self.start_month = start_month
        if start_year is not None:
            self.start_year = start_year
        if end_month is not None:
            self.end_month = end_month
        if end_year is not None:
            self.end_year = end_year
        if is_high_education is not None:
            self.is_high_education = is_high_education
        if city is not None:
            self.city = city
        if state is not None:
            self.state = state
        if country is not None:
            self.country = country
        if university_name is not None:
            self.university_name = university_name

    @property
    def degree(self):
        """Gets the degree of this AddOrUpdateEducationRequestEducation.  # noqa: E501

        Degree or qualification obtained in the education.  # noqa: E501

        :return: The degree of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :rtype: str
        """
        return self._degree

    @degree.setter
    def degree(self, degree):
        """Sets the degree of this AddOrUpdateEducationRequestEducation.

        Degree or qualification obtained in the education.  # noqa: E501

        :param degree: The degree of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :type: str
        """

        self._degree = degree

    @property
    def field_of_study(self):
        """Gets the field_of_study of this AddOrUpdateEducationRequestEducation.  # noqa: E501

        Field of study or major in the education.  # noqa: E501

        :return: The field_of_study of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :rtype: str
        """
        return self._field_of_study

    @field_of_study.setter
    def field_of_study(self, field_of_study):
        """Sets the field_of_study of this AddOrUpdateEducationRequestEducation.

        Field of study or major in the education.  # noqa: E501

        :param field_of_study: The field_of_study of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :type: str
        """

        self._field_of_study = field_of_study

    @property
    def school_name(self):
        """Gets the school_name of this AddOrUpdateEducationRequestEducation.  # noqa: E501

        Name of the educational institution or school.  # noqa: E501

        :return: The school_name of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :rtype: str
        """
        return self._school_name

    @school_name.setter
    def school_name(self, school_name):
        """Sets the school_name of this AddOrUpdateEducationRequestEducation.

        Name of the educational institution or school.  # noqa: E501

        :param school_name: The school_name of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :type: str
        """

        self._school_name = school_name

    @property
    def start_month(self):
        """Gets the start_month of this AddOrUpdateEducationRequestEducation.  # noqa: E501

        Start month of the education (numeric value).  # noqa: E501

        :return: The start_month of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :rtype: int
        """
        return self._start_month

    @start_month.setter
    def start_month(self, start_month):
        """Sets the start_month of this AddOrUpdateEducationRequestEducation.

        Start month of the education (numeric value).  # noqa: E501

        :param start_month: The start_month of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :type: int
        """

        self._start_month = start_month

    @property
    def start_year(self):
        """Gets the start_year of this AddOrUpdateEducationRequestEducation.  # noqa: E501

        Start year of the education (numeric value).  # noqa: E501

        :return: The start_year of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :rtype: int
        """
        return self._start_year

    @start_year.setter
    def start_year(self, start_year):
        """Sets the start_year of this AddOrUpdateEducationRequestEducation.

        Start year of the education (numeric value).  # noqa: E501

        :param start_year: The start_year of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :type: int
        """

        self._start_year = start_year

    @property
    def end_month(self):
        """Gets the end_month of this AddOrUpdateEducationRequestEducation.  # noqa: E501

        End month of the education (numeric value).  # noqa: E501

        :return: The end_month of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :rtype: int
        """
        return self._end_month

    @end_month.setter
    def end_month(self, end_month):
        """Sets the end_month of this AddOrUpdateEducationRequestEducation.

        End month of the education (numeric value).  # noqa: E501

        :param end_month: The end_month of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :type: int
        """

        self._end_month = end_month

    @property
    def end_year(self):
        """Gets the end_year of this AddOrUpdateEducationRequestEducation.  # noqa: E501

        End year of the education (numeric value).  # noqa: E501

        :return: The end_year of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :rtype: int
        """
        return self._end_year

    @end_year.setter
    def end_year(self, end_year):
        """Sets the end_year of this AddOrUpdateEducationRequestEducation.

        End year of the education (numeric value).  # noqa: E501

        :param end_year: The end_year of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :type: int
        """

        self._end_year = end_year

    @property
    def is_high_education(self):
        """Gets the is_high_education of this AddOrUpdateEducationRequestEducation.  # noqa: E501

        Boolean indicating whether the education is a high education level.  # noqa: E501

        :return: The is_high_education of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :rtype: bool
        """
        return self._is_high_education

    @is_high_education.setter
    def is_high_education(self, is_high_education):
        """Sets the is_high_education of this AddOrUpdateEducationRequestEducation.

        Boolean indicating whether the education is a high education level.  # noqa: E501

        :param is_high_education: The is_high_education of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :type: bool
        """

        self._is_high_education = is_high_education

    @property
    def city(self):
        """Gets the city of this AddOrUpdateEducationRequestEducation.  # noqa: E501

        City where the educational institution is located.  # noqa: E501

        :return: The city of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :rtype: str
        """
        return self._city

    @city.setter
    def city(self, city):
        """Sets the city of this AddOrUpdateEducationRequestEducation.

        City where the educational institution is located.  # noqa: E501

        :param city: The city of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :type: str
        """

        self._city = city

    @property
    def state(self):
        """Gets the state of this AddOrUpdateEducationRequestEducation.  # noqa: E501

        State or region where the educational institution is located.  # noqa: E501

        :return: The state of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this AddOrUpdateEducationRequestEducation.

        State or region where the educational institution is located.  # noqa: E501

        :param state: The state of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :type: str
        """

        self._state = state

    @property
    def country(self):
        """Gets the country of this AddOrUpdateEducationRequestEducation.  # noqa: E501

        Country where the educational institution is located.  # noqa: E501

        :return: The country of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country):
        """Sets the country of this AddOrUpdateEducationRequestEducation.

        Country where the educational institution is located.  # noqa: E501

        :param country: The country of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :type: str
        """

        self._country = country

    @property
    def university_name(self):
        """Gets the university_name of this AddOrUpdateEducationRequestEducation.  # noqa: E501

        Name of the university associated with the education.  # noqa: E501

        :return: The university_name of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :rtype: str
        """
        return self._university_name

    @university_name.setter
    def university_name(self, university_name):
        """Sets the university_name of this AddOrUpdateEducationRequestEducation.

        Name of the university associated with the education.  # noqa: E501

        :param university_name: The university_name of this AddOrUpdateEducationRequestEducation.  # noqa: E501
        :type: str
        """

        self._university_name = university_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AddOrUpdateEducationRequestEducation, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddOrUpdateEducationRequestEducation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
