# coding: utf-8

"""
    candidates-api

    The Candidate APIs allows you to add, update and delete candidates.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class CandidateDataCandidateContacts(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'phone_number': 'str',
        'country_code': 'str',
        'status': 'str',
        'type': 'str'
    }

    attribute_map = {
        'phone_number': 'phoneNumber',
        'country_code': 'countryCode',
        'status': 'status',
        'type': 'type'
    }

    def __init__(self, phone_number=None, country_code=None, status=None, type=None):  # noqa: E501
        """CandidateDataCandidateContacts - a model defined in Swagger"""  # noqa: E501
        self._phone_number = None
        self._country_code = None
        self._status = None
        self._type = None
        self.discriminator = None
        if phone_number is not None:
            self.phone_number = phone_number
        if country_code is not None:
            self.country_code = country_code
        if status is not None:
            self.status = status
        if type is not None:
            self.type = type

    @property
    def phone_number(self):
        """Gets the phone_number of this CandidateDataCandidateContacts.  # noqa: E501

        A string representing the phone number in the contact entry.  # noqa: E501

        :return: The phone_number of this CandidateDataCandidateContacts.  # noqa: E501
        :rtype: str
        """
        return self._phone_number

    @phone_number.setter
    def phone_number(self, phone_number):
        """Sets the phone_number of this CandidateDataCandidateContacts.

        A string representing the phone number in the contact entry.  # noqa: E501

        :param phone_number: The phone_number of this CandidateDataCandidateContacts.  # noqa: E501
        :type: str
        """

        self._phone_number = phone_number

    @property
    def country_code(self):
        """Gets the country_code of this CandidateDataCandidateContacts.  # noqa: E501

        A string representing the country code of the phone number.  # noqa: E501

        :return: The country_code of this CandidateDataCandidateContacts.  # noqa: E501
        :rtype: str
        """
        return self._country_code

    @country_code.setter
    def country_code(self, country_code):
        """Sets the country_code of this CandidateDataCandidateContacts.

        A string representing the country code of the phone number.  # noqa: E501

        :param country_code: The country_code of this CandidateDataCandidateContacts.  # noqa: E501
        :type: str
        """

        self._country_code = country_code

    @property
    def status(self):
        """Gets the status of this CandidateDataCandidateContacts.  # noqa: E501

        A string representing the status of the contact entry.  # noqa: E501

        :return: The status of this CandidateDataCandidateContacts.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this CandidateDataCandidateContacts.

        A string representing the status of the contact entry.  # noqa: E501

        :param status: The status of this CandidateDataCandidateContacts.  # noqa: E501
        :type: str
        """

        self._status = status

    @property
    def type(self):
        """Gets the type of this CandidateDataCandidateContacts.  # noqa: E501

        A string representing the type of contact entry.  # noqa: E501

        :return: The type of this CandidateDataCandidateContacts.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this CandidateDataCandidateContacts.

        A string representing the type of contact entry.  # noqa: E501

        :param type: The type of this CandidateDataCandidateContacts.  # noqa: E501
        :type: str
        """

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CandidateDataCandidateContacts, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CandidateDataCandidateContacts):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
