# coding: utf-8

"""
    candidates-api

    The Candidate APIs allows you to add, update and delete candidates.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class CertificationDataCertifications(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'certification_number': 'str',
        'institute': 'str',
        'start_date': 'float',
        'issued_date': 'CertificationDataIssuedDate',
        'expiry_date': 'CertificationDataExpiryDate'
    }

    attribute_map = {
        'name': 'name',
        'certification_number': 'certificationNumber',
        'institute': 'institute',
        'start_date': 'startDate',
        'issued_date': 'issuedDate',
        'expiry_date': 'expiryDate'
    }

    def __init__(self, name=None, certification_number=None, institute=None, start_date=None, issued_date=None, expiry_date=None):  # noqa: E501
        """CertificationDataCertifications - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._certification_number = None
        self._institute = None
        self._start_date = None
        self._issued_date = None
        self._expiry_date = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if certification_number is not None:
            self.certification_number = certification_number
        if institute is not None:
            self.institute = institute
        if start_date is not None:
            self.start_date = start_date
        if issued_date is not None:
            self.issued_date = issued_date
        if expiry_date is not None:
            self.expiry_date = expiry_date

    @property
    def name(self):
        """Gets the name of this CertificationDataCertifications.  # noqa: E501

        The name of the certification.  # noqa: E501

        :return: The name of this CertificationDataCertifications.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CertificationDataCertifications.

        The name of the certification.  # noqa: E501

        :param name: The name of this CertificationDataCertifications.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def certification_number(self):
        """Gets the certification_number of this CertificationDataCertifications.  # noqa: E501

        The unique certification number.  # noqa: E501

        :return: The certification_number of this CertificationDataCertifications.  # noqa: E501
        :rtype: str
        """
        return self._certification_number

    @certification_number.setter
    def certification_number(self, certification_number):
        """Sets the certification_number of this CertificationDataCertifications.

        The unique certification number.  # noqa: E501

        :param certification_number: The certification_number of this CertificationDataCertifications.  # noqa: E501
        :type: str
        """

        self._certification_number = certification_number

    @property
    def institute(self):
        """Gets the institute of this CertificationDataCertifications.  # noqa: E501

        The institution or organization that issued the certification.  # noqa: E501

        :return: The institute of this CertificationDataCertifications.  # noqa: E501
        :rtype: str
        """
        return self._institute

    @institute.setter
    def institute(self, institute):
        """Sets the institute of this CertificationDataCertifications.

        The institution or organization that issued the certification.  # noqa: E501

        :param institute: The institute of this CertificationDataCertifications.  # noqa: E501
        :type: str
        """

        self._institute = institute

    @property
    def start_date(self):
        """Gets the start_date of this CertificationDataCertifications.  # noqa: E501

        The numeric representation of the certification start date.  # noqa: E501

        :return: The start_date of this CertificationDataCertifications.  # noqa: E501
        :rtype: float
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this CertificationDataCertifications.

        The numeric representation of the certification start date.  # noqa: E501

        :param start_date: The start_date of this CertificationDataCertifications.  # noqa: E501
        :type: float
        """

        self._start_date = start_date

    @property
    def issued_date(self):
        """Gets the issued_date of this CertificationDataCertifications.  # noqa: E501


        :return: The issued_date of this CertificationDataCertifications.  # noqa: E501
        :rtype: CertificationDataIssuedDate
        """
        return self._issued_date

    @issued_date.setter
    def issued_date(self, issued_date):
        """Sets the issued_date of this CertificationDataCertifications.


        :param issued_date: The issued_date of this CertificationDataCertifications.  # noqa: E501
        :type: CertificationDataIssuedDate
        """

        self._issued_date = issued_date

    @property
    def expiry_date(self):
        """Gets the expiry_date of this CertificationDataCertifications.  # noqa: E501


        :return: The expiry_date of this CertificationDataCertifications.  # noqa: E501
        :rtype: CertificationDataExpiryDate
        """
        return self._expiry_date

    @expiry_date.setter
    def expiry_date(self, expiry_date):
        """Sets the expiry_date of this CertificationDataCertifications.


        :param expiry_date: The expiry_date of this CertificationDataCertifications.  # noqa: E501
        :type: CertificationDataExpiryDate
        """

        self._expiry_date = expiry_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CertificationDataCertifications, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CertificationDataCertifications):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
