# coding: utf-8

"""
    candidates-api

    The Candidate APIs allows you to add, update and delete candidates.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class CreateCandidateRequestEmailList(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'email': 'str',
        'type': 'str',
        'status': 'str'
    }

    attribute_map = {
        'email': 'email',
        'type': 'type',
        'status': 'status'
    }

    def __init__(self, email=None, type=None, status=None):  # noqa: E501
        """CreateCandidateRequestEmailList - a model defined in Swagger"""  # noqa: E501
        self._email = None
        self._type = None
        self._status = None
        self.discriminator = None
        self.email = email
        self.type = type
        self.status = status

    @property
    def email(self):
        """Gets the email of this CreateCandidateRequestEmailList.  # noqa: E501

        The email address of the candidate. (Example: xyz@gmail.com)  # noqa: E501

        :return: The email of this CreateCandidateRequestEmailList.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this CreateCandidateRequestEmailList.

        The email address of the candidate. (Example: xyz@gmail.com)  # noqa: E501

        :param email: The email of this CreateCandidateRequestEmailList.  # noqa: E501
        :type: str
        """
        if email is None:
            raise ValueError("Invalid value for `email`, must not be `None`")  # noqa: E501

        self._email = email

    @property
    def type(self):
        """Gets the type of this CreateCandidateRequestEmailList.  # noqa: E501

        The type of email (e.g., 'Primary' or 'Secondary').  # noqa: E501

        :return: The type of this CreateCandidateRequestEmailList.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this CreateCandidateRequestEmailList.

        The type of email (e.g., 'Primary' or 'Secondary').  # noqa: E501

        :param type: The type of this CreateCandidateRequestEmailList.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def status(self):
        """Gets the status of this CreateCandidateRequestEmailList.  # noqa: E501

        The status of the email (e.g., 'Primary' or 'Secondary').  # noqa: E501

        :return: The status of this CreateCandidateRequestEmailList.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this CreateCandidateRequestEmailList.

        The status of the email (e.g., 'Primary' or 'Secondary').  # noqa: E501

        :param status: The status of this CreateCandidateRequestEmailList.  # noqa: E501
        :type: str
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501
        allowed_values = ["Primary", "Secondary"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateCandidateRequestEmailList, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateCandidateRequestEmailList):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
