# coding: utf-8

"""
    candidates-api

    The Candidate APIs allows you to add, update and delete candidates.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class PreferredLocationDataPreferredLocationList(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'location': 'str',
        'city': 'str',
        'country': 'str',
        'state': 'str',
        'zip_code': 'str'
    }

    attribute_map = {
        'location': 'location',
        'city': 'city',
        'country': 'country',
        'state': 'state',
        'zip_code': 'zipCode'
    }

    def __init__(self, location=None, city=None, country=None, state=None, zip_code=None):  # noqa: E501
        """PreferredLocationDataPreferredLocationList - a model defined in Swagger"""  # noqa: E501
        self._location = None
        self._city = None
        self._country = None
        self._state = None
        self._zip_code = None
        self.discriminator = None
        if location is not None:
            self.location = location
        if city is not None:
            self.city = city
        if country is not None:
            self.country = country
        if state is not None:
            self.state = state
        if zip_code is not None:
            self.zip_code = zip_code

    @property
    def location(self):
        """Gets the location of this PreferredLocationDataPreferredLocationList.  # noqa: E501

        A string representing the preferred location.  # noqa: E501

        :return: The location of this PreferredLocationDataPreferredLocationList.  # noqa: E501
        :rtype: str
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this PreferredLocationDataPreferredLocationList.

        A string representing the preferred location.  # noqa: E501

        :param location: The location of this PreferredLocationDataPreferredLocationList.  # noqa: E501
        :type: str
        """

        self._location = location

    @property
    def city(self):
        """Gets the city of this PreferredLocationDataPreferredLocationList.  # noqa: E501

        A string representing the city of the preferred location.  # noqa: E501

        :return: The city of this PreferredLocationDataPreferredLocationList.  # noqa: E501
        :rtype: str
        """
        return self._city

    @city.setter
    def city(self, city):
        """Sets the city of this PreferredLocationDataPreferredLocationList.

        A string representing the city of the preferred location.  # noqa: E501

        :param city: The city of this PreferredLocationDataPreferredLocationList.  # noqa: E501
        :type: str
        """

        self._city = city

    @property
    def country(self):
        """Gets the country of this PreferredLocationDataPreferredLocationList.  # noqa: E501

        A string representing the country of the preferred location.  # noqa: E501

        :return: The country of this PreferredLocationDataPreferredLocationList.  # noqa: E501
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country):
        """Sets the country of this PreferredLocationDataPreferredLocationList.

        A string representing the country of the preferred location.  # noqa: E501

        :param country: The country of this PreferredLocationDataPreferredLocationList.  # noqa: E501
        :type: str
        """

        self._country = country

    @property
    def state(self):
        """Gets the state of this PreferredLocationDataPreferredLocationList.  # noqa: E501

        A string representing the state of the preferred location.  # noqa: E501

        :return: The state of this PreferredLocationDataPreferredLocationList.  # noqa: E501
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this PreferredLocationDataPreferredLocationList.

        A string representing the state of the preferred location.  # noqa: E501

        :param state: The state of this PreferredLocationDataPreferredLocationList.  # noqa: E501
        :type: str
        """

        self._state = state

    @property
    def zip_code(self):
        """Gets the zip_code of this PreferredLocationDataPreferredLocationList.  # noqa: E501

        A string representing the ZIP code of the preferred location.  # noqa: E501

        :return: The zip_code of this PreferredLocationDataPreferredLocationList.  # noqa: E501
        :rtype: str
        """
        return self._zip_code

    @zip_code.setter
    def zip_code(self, zip_code):
        """Sets the zip_code of this PreferredLocationDataPreferredLocationList.

        A string representing the ZIP code of the preferred location.  # noqa: E501

        :param zip_code: The zip_code of this PreferredLocationDataPreferredLocationList.  # noqa: E501
        :type: str
        """

        self._zip_code = zip_code

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PreferredLocationDataPreferredLocationList, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PreferredLocationDataPreferredLocationList):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
