# coding: utf-8

"""
    candidates-api

    The Candidate APIs allows you to add, update and delete candidates.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class UpdatePreferredLocationRequest(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'action': 'str',
        'preferred_location_list': 'list[UpdatePreferredLocationRequestPreferredLocationList]'
    }

    attribute_map = {
        'action': 'action',
        'preferred_location_list': 'preferredLocationList'
    }

    def __init__(self, action=None, preferred_location_list=None):  # noqa: E501
        """UpdatePreferredLocationRequest - a model defined in Swagger"""  # noqa: E501
        self._action = None
        self._preferred_location_list = None
        self.discriminator = None
        if action is not None:
            self.action = action
        if preferred_location_list is not None:
            self.preferred_location_list = preferred_location_list

    @property
    def action(self):
        """Gets the action of this UpdatePreferredLocationRequest.  # noqa: E501

        Action to perform on the preferred locations. Valid values: 'add', 'remove', 'replace'.  # noqa: E501

        :return: The action of this UpdatePreferredLocationRequest.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this UpdatePreferredLocationRequest.

        Action to perform on the preferred locations. Valid values: 'add', 'remove', 'replace'.  # noqa: E501

        :param action: The action of this UpdatePreferredLocationRequest.  # noqa: E501
        :type: str
        """

        self._action = action

    @property
    def preferred_location_list(self):
        """Gets the preferred_location_list of this UpdatePreferredLocationRequest.  # noqa: E501

        List of preferred locations to be added, removed, or replaced.  # noqa: E501

        :return: The preferred_location_list of this UpdatePreferredLocationRequest.  # noqa: E501
        :rtype: list[UpdatePreferredLocationRequestPreferredLocationList]
        """
        return self._preferred_location_list

    @preferred_location_list.setter
    def preferred_location_list(self, preferred_location_list):
        """Sets the preferred_location_list of this UpdatePreferredLocationRequest.

        List of preferred locations to be added, removed, or replaced.  # noqa: E501

        :param preferred_location_list: The preferred_location_list of this UpdatePreferredLocationRequest.  # noqa: E501
        :type: list[UpdatePreferredLocationRequestPreferredLocationList]
        """

        self._preferred_location_list = preferred_location_list

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdatePreferredLocationRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdatePreferredLocationRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
