# coding: utf-8

"""
    candidates-api

    The Candidate APIs allows you to add, update and delete candidates.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class UpdateRecommendationsRequestRecommendations(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'first_name': 'str',
        'last_name': 'str',
        'text': 'str',
        'type': 'str',
        'relation': 'str'
    }

    attribute_map = {
        'first_name': 'firstName',
        'last_name': 'lastName',
        'text': 'text',
        'type': 'type',
        'relation': 'relation'
    }

    def __init__(self, first_name=None, last_name=None, text=None, type=None, relation=None):  # noqa: E501
        """UpdateRecommendationsRequestRecommendations - a model defined in Swagger"""  # noqa: E501
        self._first_name = None
        self._last_name = None
        self._text = None
        self._type = None
        self._relation = None
        self.discriminator = None
        if first_name is not None:
            self.first_name = first_name
        if last_name is not None:
            self.last_name = last_name
        if text is not None:
            self.text = text
        if type is not None:
            self.type = type
        if relation is not None:
            self.relation = relation

    @property
    def first_name(self):
        """Gets the first_name of this UpdateRecommendationsRequestRecommendations.  # noqa: E501

        First name of the person providing the recommendation.  # noqa: E501

        :return: The first_name of this UpdateRecommendationsRequestRecommendations.  # noqa: E501
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """Sets the first_name of this UpdateRecommendationsRequestRecommendations.

        First name of the person providing the recommendation.  # noqa: E501

        :param first_name: The first_name of this UpdateRecommendationsRequestRecommendations.  # noqa: E501
        :type: str
        """

        self._first_name = first_name

    @property
    def last_name(self):
        """Gets the last_name of this UpdateRecommendationsRequestRecommendations.  # noqa: E501

        Last name of the person providing the recommendation.  # noqa: E501

        :return: The last_name of this UpdateRecommendationsRequestRecommendations.  # noqa: E501
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """Sets the last_name of this UpdateRecommendationsRequestRecommendations.

        Last name of the person providing the recommendation.  # noqa: E501

        :param last_name: The last_name of this UpdateRecommendationsRequestRecommendations.  # noqa: E501
        :type: str
        """

        self._last_name = last_name

    @property
    def text(self):
        """Gets the text of this UpdateRecommendationsRequestRecommendations.  # noqa: E501

        Text of the recommendation.  # noqa: E501

        :return: The text of this UpdateRecommendationsRequestRecommendations.  # noqa: E501
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text):
        """Sets the text of this UpdateRecommendationsRequestRecommendations.

        Text of the recommendation.  # noqa: E501

        :param text: The text of this UpdateRecommendationsRequestRecommendations.  # noqa: E501
        :type: str
        """

        self._text = text

    @property
    def type(self):
        """Gets the type of this UpdateRecommendationsRequestRecommendations.  # noqa: E501

        Type of recommendation.  # noqa: E501

        :return: The type of this UpdateRecommendationsRequestRecommendations.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this UpdateRecommendationsRequestRecommendations.

        Type of recommendation.  # noqa: E501

        :param type: The type of this UpdateRecommendationsRequestRecommendations.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def relation(self):
        """Gets the relation of this UpdateRecommendationsRequestRecommendations.  # noqa: E501

        Relationship or association with the candidate.  # noqa: E501

        :return: The relation of this UpdateRecommendationsRequestRecommendations.  # noqa: E501
        :rtype: str
        """
        return self._relation

    @relation.setter
    def relation(self, relation):
        """Sets the relation of this UpdateRecommendationsRequestRecommendations.

        Relationship or association with the candidate.  # noqa: E501

        :param relation: The relation of this UpdateRecommendationsRequestRecommendations.  # noqa: E501
        :type: str
        """

        self._relation = relation

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateRecommendationsRequestRecommendations, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateRecommendationsRequestRecommendations):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
