# coding: utf-8

"""
    candidates-api-activities

    The Note APIs allows you to Add, Get, Update and Delete Notes.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class GetNoteActivities(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'status': 'str',
        'message': 'str',
        'timestamp': 'str',
        'pagination': 'GetNoteActivitiesPagination',
        'data': 'list[GetNoteActivitiesData]'
    }

    attribute_map = {
        'status': 'status',
        'message': 'message',
        'timestamp': 'timestamp',
        'pagination': 'pagination',
        'data': 'data'
    }

    def __init__(self, status=None, message=None, timestamp=None, pagination=None, data=None):  # noqa: E501
        """GetNoteActivities - a model defined in Swagger"""  # noqa: E501
        self._status = None
        self._message = None
        self._timestamp = None
        self._pagination = None
        self._data = None
        self.discriminator = None
        self.status = status
        self.message = message
        self.timestamp = timestamp
        self.pagination = pagination
        self.data = data

    @property
    def status(self):
        """Gets the status of this GetNoteActivities.  # noqa: E501

        Indicates the status of the response. It could be a success or failure status.  # noqa: E501

        :return: The status of this GetNoteActivities.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this GetNoteActivities.

        Indicates the status of the response. It could be a success or failure status.  # noqa: E501

        :param status: The status of this GetNoteActivities.  # noqa: E501
        :type: str
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def message(self):
        """Gets the message of this GetNoteActivities.  # noqa: E501

        A human readable message providing additional information about the response. It may include details about the success or failure.  # noqa: E501

        :return: The message of this GetNoteActivities.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this GetNoteActivities.

        A human readable message providing additional information about the response. It may include details about the success or failure.  # noqa: E501

        :param message: The message of this GetNoteActivities.  # noqa: E501
        :type: str
        """
        if message is None:
            raise ValueError("Invalid value for `message`, must not be `None`")  # noqa: E501

        self._message = message

    @property
    def timestamp(self):
        """Gets the timestamp of this GetNoteActivities.  # noqa: E501

        A timestamp indicating the moment when the response was generated. This helps in tracking the timing of the response.  # noqa: E501

        :return: The timestamp of this GetNoteActivities.  # noqa: E501
        :rtype: str
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """Sets the timestamp of this GetNoteActivities.

        A timestamp indicating the moment when the response was generated. This helps in tracking the timing of the response.  # noqa: E501

        :param timestamp: The timestamp of this GetNoteActivities.  # noqa: E501
        :type: str
        """
        if timestamp is None:
            raise ValueError("Invalid value for `timestamp`, must not be `None`")  # noqa: E501

        self._timestamp = timestamp

    @property
    def pagination(self):
        """Gets the pagination of this GetNoteActivities.  # noqa: E501


        :return: The pagination of this GetNoteActivities.  # noqa: E501
        :rtype: GetNoteActivitiesPagination
        """
        return self._pagination

    @pagination.setter
    def pagination(self, pagination):
        """Sets the pagination of this GetNoteActivities.


        :param pagination: The pagination of this GetNoteActivities.  # noqa: E501
        :type: GetNoteActivitiesPagination
        """
        if pagination is None:
            raise ValueError("Invalid value for `pagination`, must not be `None`")  # noqa: E501

        self._pagination = pagination

    @property
    def data(self):
        """Gets the data of this GetNoteActivities.  # noqa: E501


        :return: The data of this GetNoteActivities.  # noqa: E501
        :rtype: list[GetNoteActivitiesData]
        """
        return self._data

    @data.setter
    def data(self, data):
        """Sets the data of this GetNoteActivities.


        :param data: The data of this GetNoteActivities.  # noqa: E501
        :type: list[GetNoteActivitiesData]
        """
        if data is None:
            raise ValueError("Invalid value for `data`, must not be `None`")  # noqa: E501

        self._data = data

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetNoteActivities, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetNoteActivities):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
