# coding: utf-8

"""
    candidates-api-activities

    The Note APIs allows you to Add, Get, Update and Delete Notes.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class UnauthorizedRequest(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'status': 'str',
        'error': 'str',
        'message': 'str'
    }

    attribute_map = {
        'status': 'status',
        'error': 'error',
        'message': 'message'
    }

    def __init__(self, status='failure', error='UNAUTHORIZED', message='You are not authorized'):  # noqa: E501
        """UnauthorizedRequest - a model defined in Swagger"""  # noqa: E501
        self._status = None
        self._error = None
        self._message = None
        self.discriminator = None
        if status is not None:
            self.status = status
        if error is not None:
            self.error = error
        if message is not None:
            self.message = message

    @property
    def status(self):
        """Gets the status of this UnauthorizedRequest.  # noqa: E501

        Indicates the status of the error response. It typically represents an 'unauthorized' request.  # noqa: E501

        :return: The status of this UnauthorizedRequest.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this UnauthorizedRequest.

        Indicates the status of the error response. It typically represents an 'unauthorized' request.  # noqa: E501

        :param status: The status of this UnauthorizedRequest.  # noqa: E501
        :type: str
        """

        self._status = status

    @property
    def error(self):
        """Gets the error of this UnauthorizedRequest.  # noqa: E501

        A string representing the type of error. It is set to 'UNAUTHORIZED' to indicate that the request lacks proper authorization.  # noqa: E501

        :return: The error of this UnauthorizedRequest.  # noqa: E501
        :rtype: str
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this UnauthorizedRequest.

        A string representing the type of error. It is set to 'UNAUTHORIZED' to indicate that the request lacks proper authorization.  # noqa: E501

        :param error: The error of this UnauthorizedRequest.  # noqa: E501
        :type: str
        """

        self._error = error

    @property
    def message(self):
        """Gets the message of this UnauthorizedRequest.  # noqa: E501

        A human readable message providing additional information about the 'unauthorized' error. It informs the user that they do not have the necessary authorization for the requested action.  # noqa: E501

        :return: The message of this UnauthorizedRequest.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this UnauthorizedRequest.

        A human readable message providing additional information about the 'unauthorized' error. It informs the user that they do not have the necessary authorization for the requested action.  # noqa: E501

        :param message: The message of this UnauthorizedRequest.  # noqa: E501
        :type: str
        """

        self._message = message

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UnauthorizedRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UnauthorizedRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
