# coding: utf-8

"""
    communications-sms

    These APIs ensures an easy integration process of SMS management for developers to send, read, and track SMS histories within applications.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class OptInHistoryDetailsContent(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'phone_number': 'str',
        'action_type': 'str',
        'reason': 'str',
        'created_date': 'int'
    }

    attribute_map = {
        'phone_number': 'phoneNumber',
        'action_type': 'actionType',
        'reason': 'reason',
        'created_date': 'createdDate'
    }

    def __init__(self, phone_number=None, action_type=None, reason=None, created_date=None):  # noqa: E501
        """OptInHistoryDetailsContent - a model defined in Swagger"""  # noqa: E501
        self._phone_number = None
        self._action_type = None
        self._reason = None
        self._created_date = None
        self.discriminator = None
        self.phone_number = phone_number
        self.action_type = action_type
        self.reason = reason
        self.created_date = created_date

    @property
    def phone_number(self):
        """Gets the phone_number of this OptInHistoryDetailsContent.  # noqa: E501

        The phone number associated with the OptIn history.  # noqa: E501

        :return: The phone_number of this OptInHistoryDetailsContent.  # noqa: E501
        :rtype: str
        """
        return self._phone_number

    @phone_number.setter
    def phone_number(self, phone_number):
        """Sets the phone_number of this OptInHistoryDetailsContent.

        The phone number associated with the OptIn history.  # noqa: E501

        :param phone_number: The phone_number of this OptInHistoryDetailsContent.  # noqa: E501
        :type: str
        """
        if phone_number is None:
            raise ValueError("Invalid value for `phone_number`, must not be `None`")  # noqa: E501

        self._phone_number = phone_number

    @property
    def action_type(self):
        """Gets the action_type of this OptInHistoryDetailsContent.  # noqa: E501

        The type of action associated with the OptIn history.  # noqa: E501

        :return: The action_type of this OptInHistoryDetailsContent.  # noqa: E501
        :rtype: str
        """
        return self._action_type

    @action_type.setter
    def action_type(self, action_type):
        """Sets the action_type of this OptInHistoryDetailsContent.

        The type of action associated with the OptIn history.  # noqa: E501

        :param action_type: The action_type of this OptInHistoryDetailsContent.  # noqa: E501
        :type: str
        """
        if action_type is None:
            raise ValueError("Invalid value for `action_type`, must not be `None`")  # noqa: E501

        self._action_type = action_type

    @property
    def reason(self):
        """Gets the reason of this OptInHistoryDetailsContent.  # noqa: E501

        The reason for the OptIn history entry.  # noqa: E501

        :return: The reason of this OptInHistoryDetailsContent.  # noqa: E501
        :rtype: str
        """
        return self._reason

    @reason.setter
    def reason(self, reason):
        """Sets the reason of this OptInHistoryDetailsContent.

        The reason for the OptIn history entry.  # noqa: E501

        :param reason: The reason of this OptInHistoryDetailsContent.  # noqa: E501
        :type: str
        """
        if reason is None:
            raise ValueError("Invalid value for `reason`, must not be `None`")  # noqa: E501

        self._reason = reason

    @property
    def created_date(self):
        """Gets the created_date of this OptInHistoryDetailsContent.  # noqa: E501

        The timestamp when the OptIn history entry was created.  # noqa: E501

        :return: The created_date of this OptInHistoryDetailsContent.  # noqa: E501
        :rtype: int
        """
        return self._created_date

    @created_date.setter
    def created_date(self, created_date):
        """Sets the created_date of this OptInHistoryDetailsContent.

        The timestamp when the OptIn history entry was created.  # noqa: E501

        :param created_date: The created_date of this OptInHistoryDetailsContent.  # noqa: E501
        :type: int
        """
        if created_date is None:
            raise ValueError("Invalid value for `created_date`, must not be `None`")  # noqa: E501

        self._created_date = created_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OptInHistoryDetailsContent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OptInHistoryDetailsContent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
