# coding: utf-8

"""
    employees-api-referral

    The employee referral APIs are used to refer, track and recommend jobs to external candidates.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@phenompeople.com
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class GetEmployeeReferralSuccessResponse(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'status': 'int',
        'message': 'str',
        'total_referrals_count': 'str',
        'candidates': 'list[GetEmployeeReferralSuccessResponseCandidates]'
    }

    attribute_map = {
        'status': 'status',
        'message': 'message',
        'total_referrals_count': 'totalReferralsCount',
        'candidates': 'candidates'
    }

    def __init__(self, status=200, message='success', total_referrals_count='0', candidates=None):  # noqa: E501
        """GetEmployeeReferralSuccessResponse - a model defined in Swagger"""  # noqa: E501
        self._status = None
        self._message = None
        self._total_referrals_count = None
        self._candidates = None
        self.discriminator = None
        if status is not None:
            self.status = status
        if message is not None:
            self.message = message
        if total_referrals_count is not None:
            self.total_referrals_count = total_referrals_count
        if candidates is not None:
            self.candidates = candidates

    @property
    def status(self):
        """Gets the status of this GetEmployeeReferralSuccessResponse.  # noqa: E501

        HTTP Status code determining the response status.  # noqa: E501

        :return: The status of this GetEmployeeReferralSuccessResponse.  # noqa: E501
        :rtype: int
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this GetEmployeeReferralSuccessResponse.

        HTTP Status code determining the response status.  # noqa: E501

        :param status: The status of this GetEmployeeReferralSuccessResponse.  # noqa: E501
        :type: int
        """

        self._status = status

    @property
    def message(self):
        """Gets the message of this GetEmployeeReferralSuccessResponse.  # noqa: E501

        Status of the API call whether it is success or failure.  # noqa: E501

        :return: The message of this GetEmployeeReferralSuccessResponse.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this GetEmployeeReferralSuccessResponse.

        Status of the API call whether it is success or failure.  # noqa: E501

        :param message: The message of this GetEmployeeReferralSuccessResponse.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def total_referrals_count(self):
        """Gets the total_referrals_count of this GetEmployeeReferralSuccessResponse.  # noqa: E501

        Total count of the referred candidates of an employee.  # noqa: E501

        :return: The total_referrals_count of this GetEmployeeReferralSuccessResponse.  # noqa: E501
        :rtype: str
        """
        return self._total_referrals_count

    @total_referrals_count.setter
    def total_referrals_count(self, total_referrals_count):
        """Sets the total_referrals_count of this GetEmployeeReferralSuccessResponse.

        Total count of the referred candidates of an employee.  # noqa: E501

        :param total_referrals_count: The total_referrals_count of this GetEmployeeReferralSuccessResponse.  # noqa: E501
        :type: str
        """

        self._total_referrals_count = total_referrals_count

    @property
    def candidates(self):
        """Gets the candidates of this GetEmployeeReferralSuccessResponse.  # noqa: E501


        :return: The candidates of this GetEmployeeReferralSuccessResponse.  # noqa: E501
        :rtype: list[GetEmployeeReferralSuccessResponseCandidates]
        """
        return self._candidates

    @candidates.setter
    def candidates(self, candidates):
        """Sets the candidates of this GetEmployeeReferralSuccessResponse.


        :param candidates: The candidates of this GetEmployeeReferralSuccessResponse.  # noqa: E501
        :type: list[GetEmployeeReferralSuccessResponseCandidates]
        """

        self._candidates = candidates

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetEmployeeReferralSuccessResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetEmployeeReferralSuccessResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
