# coding: utf-8

"""
    employees-api-referral

    The employee referral APIs are used to refer, track and recommend jobs to external candidates.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@phenompeople.com
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class GetEmployeeReferralSuccessResponseCandidates(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'first_name': 'str',
        'last_name': 'str',
        'email': 'str',
        'referrals': 'list[ReferralData]'
    }

    attribute_map = {
        'first_name': 'firstName',
        'last_name': 'lastName',
        'email': 'email',
        'referrals': 'referrals'
    }

    def __init__(self, first_name=None, last_name=None, email=None, referrals=None):  # noqa: E501
        """GetEmployeeReferralSuccessResponseCandidates - a model defined in Swagger"""  # noqa: E501
        self._first_name = None
        self._last_name = None
        self._email = None
        self._referrals = None
        self.discriminator = None
        if first_name is not None:
            self.first_name = first_name
        if last_name is not None:
            self.last_name = last_name
        if email is not None:
            self.email = email
        if referrals is not None:
            self.referrals = referrals

    @property
    def first_name(self):
        """Gets the first_name of this GetEmployeeReferralSuccessResponseCandidates.  # noqa: E501

        FirstName of the candidate which employee is referred.  # noqa: E501

        :return: The first_name of this GetEmployeeReferralSuccessResponseCandidates.  # noqa: E501
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """Sets the first_name of this GetEmployeeReferralSuccessResponseCandidates.

        FirstName of the candidate which employee is referred.  # noqa: E501

        :param first_name: The first_name of this GetEmployeeReferralSuccessResponseCandidates.  # noqa: E501
        :type: str
        """

        self._first_name = first_name

    @property
    def last_name(self):
        """Gets the last_name of this GetEmployeeReferralSuccessResponseCandidates.  # noqa: E501

        LastName of the candidate which employee is referred.  # noqa: E501

        :return: The last_name of this GetEmployeeReferralSuccessResponseCandidates.  # noqa: E501
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """Sets the last_name of this GetEmployeeReferralSuccessResponseCandidates.

        LastName of the candidate which employee is referred.  # noqa: E501

        :param last_name: The last_name of this GetEmployeeReferralSuccessResponseCandidates.  # noqa: E501
        :type: str
        """

        self._last_name = last_name

    @property
    def email(self):
        """Gets the email of this GetEmployeeReferralSuccessResponseCandidates.  # noqa: E501

        Email of the candidate which employee is referred.  # noqa: E501

        :return: The email of this GetEmployeeReferralSuccessResponseCandidates.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this GetEmployeeReferralSuccessResponseCandidates.

        Email of the candidate which employee is referred.  # noqa: E501

        :param email: The email of this GetEmployeeReferralSuccessResponseCandidates.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def referrals(self):
        """Gets the referrals of this GetEmployeeReferralSuccessResponseCandidates.  # noqa: E501


        :return: The referrals of this GetEmployeeReferralSuccessResponseCandidates.  # noqa: E501
        :rtype: list[ReferralData]
        """
        return self._referrals

    @referrals.setter
    def referrals(self, referrals):
        """Sets the referrals of this GetEmployeeReferralSuccessResponseCandidates.


        :param referrals: The referrals of this GetEmployeeReferralSuccessResponseCandidates.  # noqa: E501
        :type: list[ReferralData]
        """

        self._referrals = referrals

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetEmployeeReferralSuccessResponseCandidates, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetEmployeeReferralSuccessResponseCandidates):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
