# coding: utf-8

"""
    employees-api-referral

    The employee referral APIs are used to refer, track and recommend jobs to external candidates.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@phenompeople.com
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class GetReferralRecommendationsResponse(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'status': 'int',
        'message': 'str',
        'recommendations': 'list[JobRecommendations]'
    }

    attribute_map = {
        'status': 'status',
        'message': 'message',
        'recommendations': 'recommendations'
    }

    def __init__(self, status=200, message='success', recommendations=None):  # noqa: E501
        """GetReferralRecommendationsResponse - a model defined in Swagger"""  # noqa: E501
        self._status = None
        self._message = None
        self._recommendations = None
        self.discriminator = None
        if status is not None:
            self.status = status
        if message is not None:
            self.message = message
        if recommendations is not None:
            self.recommendations = recommendations

    @property
    def status(self):
        """Gets the status of this GetReferralRecommendationsResponse.  # noqa: E501

        HTTP Status code determining the response status.  # noqa: E501

        :return: The status of this GetReferralRecommendationsResponse.  # noqa: E501
        :rtype: int
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this GetReferralRecommendationsResponse.

        HTTP Status code determining the response status.  # noqa: E501

        :param status: The status of this GetReferralRecommendationsResponse.  # noqa: E501
        :type: int
        """

        self._status = status

    @property
    def message(self):
        """Gets the message of this GetReferralRecommendationsResponse.  # noqa: E501

        Status of the API call whether it is success or failure.  # noqa: E501

        :return: The message of this GetReferralRecommendationsResponse.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this GetReferralRecommendationsResponse.

        Status of the API call whether it is success or failure.  # noqa: E501

        :param message: The message of this GetReferralRecommendationsResponse.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def recommendations(self):
        """Gets the recommendations of this GetReferralRecommendationsResponse.  # noqa: E501


        :return: The recommendations of this GetReferralRecommendationsResponse.  # noqa: E501
        :rtype: list[JobRecommendations]
        """
        return self._recommendations

    @recommendations.setter
    def recommendations(self, recommendations):
        """Sets the recommendations of this GetReferralRecommendationsResponse.


        :param recommendations: The recommendations of this GetReferralRecommendationsResponse.  # noqa: E501
        :type: list[JobRecommendations]
        """

        self._recommendations = recommendations

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetReferralRecommendationsResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetReferralRecommendationsResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
