# coding: utf-8

"""
    employees-api-referral

    The employee referral APIs are used to refer, track and recommend jobs to external candidates.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@phenompeople.com
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class JobRecommendations(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'job_id': 'str',
        'title': 'str'
    }

    attribute_map = {
        'job_id': 'jobId',
        'title': 'title'
    }

    def __init__(self, job_id=None, title=None):  # noqa: E501
        """JobRecommendations - a model defined in Swagger"""  # noqa: E501
        self._job_id = None
        self._title = None
        self.discriminator = None
        if job_id is not None:
            self.job_id = job_id
        if title is not None:
            self.title = title

    @property
    def job_id(self):
        """Gets the job_id of this JobRecommendations.  # noqa: E501

        JobId- unique field to identify the job.  # noqa: E501

        :return: The job_id of this JobRecommendations.  # noqa: E501
        :rtype: str
        """
        return self._job_id

    @job_id.setter
    def job_id(self, job_id):
        """Sets the job_id of this JobRecommendations.

        JobId- unique field to identify the job.  # noqa: E501

        :param job_id: The job_id of this JobRecommendations.  # noqa: E501
        :type: str
        """

        self._job_id = job_id

    @property
    def title(self):
        """Gets the title of this JobRecommendations.  # noqa: E501

        Title of the job.  # noqa: E501

        :return: The title of this JobRecommendations.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this JobRecommendations.

        Title of the job.  # noqa: E501

        :param title: The title of this JobRecommendations.  # noqa: E501
        :type: str
        """

        self._title = title

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(JobRecommendations, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, JobRecommendations):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
