# coding: utf-8

"""
    evaluation-api

    Hiring Manager can view all the pending tasks and evaluate the interview if any pending interviews.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from phenom.commons.api_client import ApiClient


class InterviewEvaluationsApi(object):
    base_path = "/evaluations"  # your base path

    def __init__(self, token, gateway_url, apikey, api_client=None):
        if api_client is None:
            api_client = ApiClient(gateway_url + self.base_path, apikey, token)
        self.api_client = api_client

    def get_candidate_evaluations(self, body, x_ph_userid, candidate_id, **kwargs):  # noqa: E501
        """Get Candidate Evaluations  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_candidate_evaluations(body, x_ph_userid, candidate_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param EvaluationsRequest body: (required)
        :param str x_ph_userid: User's unique id. (required)
        :param str candidate_id: Candidate's unique id. (required)
        :return: CandidateEvaluations
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_candidate_evaluations_with_http_info(body, x_ph_userid, candidate_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_candidate_evaluations_with_http_info(body, x_ph_userid, candidate_id, **kwargs)  # noqa: E501
            return data

    def get_candidate_evaluations_with_http_info(self, body, x_ph_userid, candidate_id, **kwargs):  # noqa: E501
        """Get Candidate Evaluations  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_candidate_evaluations_with_http_info(body, x_ph_userid, candidate_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param EvaluationsRequest body: (required)
        :param str x_ph_userid: User's unique id. (required)
        :param str candidate_id: Candidate's unique id. (required)
        :return: CandidateEvaluations
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'x_ph_userid', 'candidate_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_candidate_evaluations" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `get_candidate_evaluations`")  # noqa: E501
        # verify the required parameter 'x_ph_userid' is set
        if ('x_ph_userid' not in params or
                params['x_ph_userid'] is None):
            raise ValueError("Missing the required parameter `x_ph_userid` when calling `get_candidate_evaluations`")  # noqa: E501
        # verify the required parameter 'candidate_id' is set
        if ('candidate_id' not in params or
                params['candidate_id'] is None):
            raise ValueError("Missing the required parameter `candidate_id` when calling `get_candidate_evaluations`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'candidate_id' in params:
            path_params['candidateId'] = params['candidate_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_ph_userid' in params:
            header_params['x-ph-userid'] = params['x_ph_userid']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v3/candidates/{candidateId}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CandidateEvaluations',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_candidates_evaluations_per_job(self, job_id, candidate_id, x_ph_user_id, **kwargs):  # noqa: E501
        """Get Candidates evaluations Per Job  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_candidates_evaluations_per_job(job_id, candidate_id, x_ph_user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str job_id: The job's reference id. (required)
        :param str candidate_id: Candidate's unique id. (required)
        :param str x_ph_user_id: User's unique id. (required)
        :return: CandidateEvaluationsOnJob
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_candidates_evaluations_per_job_with_http_info(job_id, candidate_id, x_ph_user_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_candidates_evaluations_per_job_with_http_info(job_id, candidate_id, x_ph_user_id, **kwargs)  # noqa: E501
            return data

    def get_candidates_evaluations_per_job_with_http_info(self, job_id, candidate_id, x_ph_user_id, **kwargs):  # noqa: E501
        """Get Candidates evaluations Per Job  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_candidates_evaluations_per_job_with_http_info(job_id, candidate_id, x_ph_user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str job_id: The job's reference id. (required)
        :param str candidate_id: Candidate's unique id. (required)
        :param str x_ph_user_id: User's unique id. (required)
        :return: CandidateEvaluationsOnJob
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['job_id', 'candidate_id', 'x_ph_user_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_candidates_evaluations_per_job" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'job_id' is set
        if ('job_id' not in params or
                params['job_id'] is None):
            raise ValueError("Missing the required parameter `job_id` when calling `get_candidates_evaluations_per_job`")  # noqa: E501
        # verify the required parameter 'candidate_id' is set
        if ('candidate_id' not in params or
                params['candidate_id'] is None):
            raise ValueError("Missing the required parameter `candidate_id` when calling `get_candidates_evaluations_per_job`")  # noqa: E501
        # verify the required parameter 'x_ph_user_id' is set
        if ('x_ph_user_id' not in params or
                params['x_ph_user_id'] is None):
            raise ValueError("Missing the required parameter `x_ph_user_id` when calling `get_candidates_evaluations_per_job`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'job_id' in params:
            path_params['jobId'] = params['job_id']  # noqa: E501
        if 'candidate_id' in params:
            path_params['candidateId'] = params['candidate_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_ph_user_id' in params:
            header_params['x-ph-userId'] = params['x_ph_user_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v3/jobs/{jobId}/candidates/{candidateId}/interview', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CandidateEvaluationsOnJob',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_evaluation_form(self, job_id, x_ph_user_id, **kwargs):  # noqa: E501
        """Get Evaluation Form  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_evaluation_form(job_id, x_ph_user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str job_id: Job's reference id. (required)
        :param str x_ph_user_id: User's unique id. (required)
        :return: EvaluationFormsDetails
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_evaluation_form_with_http_info(job_id, x_ph_user_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_evaluation_form_with_http_info(job_id, x_ph_user_id, **kwargs)  # noqa: E501
            return data

    def get_evaluation_form_with_http_info(self, job_id, x_ph_user_id, **kwargs):  # noqa: E501
        """Get Evaluation Form  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_evaluation_form_with_http_info(job_id, x_ph_user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str job_id: Job's reference id. (required)
        :param str x_ph_user_id: User's unique id. (required)
        :return: EvaluationFormsDetails
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['job_id', 'x_ph_user_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_evaluation_form" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'job_id' is set
        if ('job_id' not in params or
                params['job_id'] is None):
            raise ValueError("Missing the required parameter `job_id` when calling `get_evaluation_form`")  # noqa: E501
        # verify the required parameter 'x_ph_user_id' is set
        if ('x_ph_user_id' not in params or
                params['x_ph_user_id'] is None):
            raise ValueError("Missing the required parameter `x_ph_user_id` when calling `get_evaluation_form`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'job_id' in params:
            path_params['jobId'] = params['job_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_ph_user_id' in params:
            header_params['x-ph-userId'] = params['x_ph_user_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v3/jobs/{jobId}/evaluation-forms', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='EvaluationFormsDetails',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_evaluation_forms(self, job_id, candidate_id, x_ph_user_id, **kwargs):  # noqa: E501
        """Get evaluation forms  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_evaluation_forms(job_id, candidate_id, x_ph_user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str job_id: Job's reference id. (required)
        :param str candidate_id: Unique id of the candidate. (required)
        :param str x_ph_user_id: User's unique id. (required)
        :return: EvaluationFormsDetails
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_evaluation_forms_with_http_info(job_id, candidate_id, x_ph_user_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_evaluation_forms_with_http_info(job_id, candidate_id, x_ph_user_id, **kwargs)  # noqa: E501
            return data

    def get_evaluation_forms_with_http_info(self, job_id, candidate_id, x_ph_user_id, **kwargs):  # noqa: E501
        """Get evaluation forms  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_evaluation_forms_with_http_info(job_id, candidate_id, x_ph_user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str job_id: Job's reference id. (required)
        :param str candidate_id: Unique id of the candidate. (required)
        :param str x_ph_user_id: User's unique id. (required)
        :return: EvaluationFormsDetails
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['job_id', 'candidate_id', 'x_ph_user_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_evaluation_forms" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'job_id' is set
        if ('job_id' not in params or
                params['job_id'] is None):
            raise ValueError("Missing the required parameter `job_id` when calling `get_evaluation_forms`")  # noqa: E501
        # verify the required parameter 'candidate_id' is set
        if ('candidate_id' not in params or
                params['candidate_id'] is None):
            raise ValueError("Missing the required parameter `candidate_id` when calling `get_evaluation_forms`")  # noqa: E501
        # verify the required parameter 'x_ph_user_id' is set
        if ('x_ph_user_id' not in params or
                params['x_ph_user_id'] is None):
            raise ValueError("Missing the required parameter `x_ph_user_id` when calling `get_evaluation_forms`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'job_id' in params:
            path_params['jobId'] = params['job_id']  # noqa: E501
        if 'candidate_id' in params:
            path_params['candidateId'] = params['candidate_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_ph_user_id' in params:
            header_params['x-ph-userId'] = params['x_ph_user_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v3/jobs/{jobId}/candidates/{candidateId}/evaluation-forms', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='EvaluationFormsDetails',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def submit_candidate_evaluation(self, body, x_ph_user_id, job_id, candidate_id, **kwargs):  # noqa: E501
        """Submit Candidate Evaluation  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.submit_candidate_evaluation(body, x_ph_user_id, job_id, candidate_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param EvaluateOnFlyRequest body: (required)
        :param str x_ph_user_id: The user's unique id. (required)
        :param str job_id: The job's reference id. (required)
        :param str candidate_id: The candidate's unique id. (required)
        :return: EvaluationOnFlyResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.submit_candidate_evaluation_with_http_info(body, x_ph_user_id, job_id, candidate_id, **kwargs)  # noqa: E501
        else:
            (data) = self.submit_candidate_evaluation_with_http_info(body, x_ph_user_id, job_id, candidate_id, **kwargs)  # noqa: E501
            return data

    def submit_candidate_evaluation_with_http_info(self, body, x_ph_user_id, job_id, candidate_id, **kwargs):  # noqa: E501
        """Submit Candidate Evaluation  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.submit_candidate_evaluation_with_http_info(body, x_ph_user_id, job_id, candidate_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param EvaluateOnFlyRequest body: (required)
        :param str x_ph_user_id: The user's unique id. (required)
        :param str job_id: The job's reference id. (required)
        :param str candidate_id: The candidate's unique id. (required)
        :return: EvaluationOnFlyResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'x_ph_user_id', 'job_id', 'candidate_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method submit_candidate_evaluation" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `submit_candidate_evaluation`")  # noqa: E501
        # verify the required parameter 'x_ph_user_id' is set
        if ('x_ph_user_id' not in params or
                params['x_ph_user_id'] is None):
            raise ValueError("Missing the required parameter `x_ph_user_id` when calling `submit_candidate_evaluation`")  # noqa: E501
        # verify the required parameter 'job_id' is set
        if ('job_id' not in params or
                params['job_id'] is None):
            raise ValueError("Missing the required parameter `job_id` when calling `submit_candidate_evaluation`")  # noqa: E501
        # verify the required parameter 'candidate_id' is set
        if ('candidate_id' not in params or
                params['candidate_id'] is None):
            raise ValueError("Missing the required parameter `candidate_id` when calling `submit_candidate_evaluation`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'job_id' in params:
            path_params['jobId'] = params['job_id']  # noqa: E501
        if 'candidate_id' in params:
            path_params['candidateId'] = params['candidate_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_ph_user_id' in params:
            header_params['x-ph-userId'] = params['x_ph_user_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v3/jobs/{jobId}/candidates/{candidateId}/submit', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='EvaluationOnFlyResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def submit_candidates_evaluations_per_job(self, body, x_ph_user_id, job_id, candidate_id, **kwargs):  # noqa: E501
        """Submit Candidates evaluations Per Job  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.submit_candidates_evaluations_per_job(body, x_ph_user_id, job_id, candidate_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CandidateJobEvaluationRequest body: (required)
        :param str x_ph_user_id: User's unique id. (required)
        :param str job_id: Job's reference id. (required)
        :param str candidate_id: Candidate's unique id. (required)
        :return: CandidateJobEvaluationResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.submit_candidates_evaluations_per_job_with_http_info(body, x_ph_user_id, job_id, candidate_id, **kwargs)  # noqa: E501
        else:
            (data) = self.submit_candidates_evaluations_per_job_with_http_info(body, x_ph_user_id, job_id, candidate_id, **kwargs)  # noqa: E501
            return data

    def submit_candidates_evaluations_per_job_with_http_info(self, body, x_ph_user_id, job_id, candidate_id, **kwargs):  # noqa: E501
        """Submit Candidates evaluations Per Job  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.submit_candidates_evaluations_per_job_with_http_info(body, x_ph_user_id, job_id, candidate_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param CandidateJobEvaluationRequest body: (required)
        :param str x_ph_user_id: User's unique id. (required)
        :param str job_id: Job's reference id. (required)
        :param str candidate_id: Candidate's unique id. (required)
        :return: CandidateJobEvaluationResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'x_ph_user_id', 'job_id', 'candidate_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method submit_candidates_evaluations_per_job" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `submit_candidates_evaluations_per_job`")  # noqa: E501
        # verify the required parameter 'x_ph_user_id' is set
        if ('x_ph_user_id' not in params or
                params['x_ph_user_id'] is None):
            raise ValueError("Missing the required parameter `x_ph_user_id` when calling `submit_candidates_evaluations_per_job`")  # noqa: E501
        # verify the required parameter 'job_id' is set
        if ('job_id' not in params or
                params['job_id'] is None):
            raise ValueError("Missing the required parameter `job_id` when calling `submit_candidates_evaluations_per_job`")  # noqa: E501
        # verify the required parameter 'candidate_id' is set
        if ('candidate_id' not in params or
                params['candidate_id'] is None):
            raise ValueError("Missing the required parameter `candidate_id` when calling `submit_candidates_evaluations_per_job`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'job_id' in params:
            path_params['jobId'] = params['job_id']  # noqa: E501
        if 'candidate_id' in params:
            path_params['candidateId'] = params['candidate_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'x_ph_user_id' in params:
            header_params['x-ph-userId'] = params['x_ph_user_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v3/jobs/{jobId}/candidates/{candidateId}/interview', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CandidateJobEvaluationResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
