# coding: utf-8

"""
    evaluation-api

    Hiring Manager can view all the pending tasks and evaluate the interview if any pending interviews.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class EvaluateOnFlyRequest(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'rating': 'float',
        'recommendation': 'str',
        'current_status': 'str',
        'new_note_display_text': 'str',
        'new_note_text': 'str',
        'additional_questions': 'list[QuestionAndAnswers]',
        'candidate_additional_fields': 'list[EvaluateOnFlyRequestCandidateAdditionalFields]',
        'form_id': 'str',
        'form_name': 'str'
    }

    attribute_map = {
        'rating': 'rating',
        'recommendation': 'recommendation',
        'current_status': 'currentStatus',
        'new_note_display_text': 'newNoteDisplayText',
        'new_note_text': 'newNoteText',
        'additional_questions': 'additionalQuestions',
        'candidate_additional_fields': 'candidateAdditionalFields',
        'form_id': 'formId',
        'form_name': 'formName'
    }

    def __init__(self, rating=None, recommendation=None, current_status=None, new_note_display_text=None, new_note_text=None, additional_questions=None, candidate_additional_fields=None, form_id=None, form_name=None):  # noqa: E501
        """EvaluateOnFlyRequest - a model defined in Swagger"""  # noqa: E501
        self._rating = None
        self._recommendation = None
        self._current_status = None
        self._new_note_display_text = None
        self._new_note_text = None
        self._additional_questions = None
        self._candidate_additional_fields = None
        self._form_id = None
        self._form_name = None
        self.discriminator = None
        if rating is not None:
            self.rating = rating
        if recommendation is not None:
            self.recommendation = recommendation
        if current_status is not None:
            self.current_status = current_status
        if new_note_display_text is not None:
            self.new_note_display_text = new_note_display_text
        if new_note_text is not None:
            self.new_note_text = new_note_text
        if additional_questions is not None:
            self.additional_questions = additional_questions
        if candidate_additional_fields is not None:
            self.candidate_additional_fields = candidate_additional_fields
        if form_id is not None:
            self.form_id = form_id
        if form_name is not None:
            self.form_name = form_name

    @property
    def rating(self):
        """Gets the rating of this EvaluateOnFlyRequest.  # noqa: E501

        Rating of the evaluation on candidate.  # noqa: E501

        :return: The rating of this EvaluateOnFlyRequest.  # noqa: E501
        :rtype: float
        """
        return self._rating

    @rating.setter
    def rating(self, rating):
        """Sets the rating of this EvaluateOnFlyRequest.

        Rating of the evaluation on candidate.  # noqa: E501

        :param rating: The rating of this EvaluateOnFlyRequest.  # noqa: E501
        :type: float
        """

        self._rating = rating

    @property
    def recommendation(self):
        """Gets the recommendation of this EvaluateOnFlyRequest.  # noqa: E501

        Recommendation of the evaluation on candidate.  # noqa: E501

        :return: The recommendation of this EvaluateOnFlyRequest.  # noqa: E501
        :rtype: str
        """
        return self._recommendation

    @recommendation.setter
    def recommendation(self, recommendation):
        """Sets the recommendation of this EvaluateOnFlyRequest.

        Recommendation of the evaluation on candidate.  # noqa: E501

        :param recommendation: The recommendation of this EvaluateOnFlyRequest.  # noqa: E501
        :type: str
        """

        self._recommendation = recommendation

    @property
    def current_status(self):
        """Gets the current_status of this EvaluateOnFlyRequest.  # noqa: E501

        Current status of the candidate to job based on given decision by user.  # noqa: E501

        :return: The current_status of this EvaluateOnFlyRequest.  # noqa: E501
        :rtype: str
        """
        return self._current_status

    @current_status.setter
    def current_status(self, current_status):
        """Sets the current_status of this EvaluateOnFlyRequest.

        Current status of the candidate to job based on given decision by user.  # noqa: E501

        :param current_status: The current_status of this EvaluateOnFlyRequest.  # noqa: E501
        :type: str
        """

        self._current_status = current_status

    @property
    def new_note_display_text(self):
        """Gets the new_note_display_text of this EvaluateOnFlyRequest.  # noqa: E501

        Note added by evaluator.  # noqa: E501

        :return: The new_note_display_text of this EvaluateOnFlyRequest.  # noqa: E501
        :rtype: str
        """
        return self._new_note_display_text

    @new_note_display_text.setter
    def new_note_display_text(self, new_note_display_text):
        """Sets the new_note_display_text of this EvaluateOnFlyRequest.

        Note added by evaluator.  # noqa: E501

        :param new_note_display_text: The new_note_display_text of this EvaluateOnFlyRequest.  # noqa: E501
        :type: str
        """

        self._new_note_display_text = new_note_display_text

    @property
    def new_note_text(self):
        """Gets the new_note_text of this EvaluateOnFlyRequest.  # noqa: E501

        Note added by evaluator.  # noqa: E501

        :return: The new_note_text of this EvaluateOnFlyRequest.  # noqa: E501
        :rtype: str
        """
        return self._new_note_text

    @new_note_text.setter
    def new_note_text(self, new_note_text):
        """Sets the new_note_text of this EvaluateOnFlyRequest.

        Note added by evaluator.  # noqa: E501

        :param new_note_text: The new_note_text of this EvaluateOnFlyRequest.  # noqa: E501
        :type: str
        """

        self._new_note_text = new_note_text

    @property
    def additional_questions(self):
        """Gets the additional_questions of this EvaluateOnFlyRequest.  # noqa: E501

        Additional questions on evaluation.  # noqa: E501

        :return: The additional_questions of this EvaluateOnFlyRequest.  # noqa: E501
        :rtype: list[QuestionAndAnswers]
        """
        return self._additional_questions

    @additional_questions.setter
    def additional_questions(self, additional_questions):
        """Sets the additional_questions of this EvaluateOnFlyRequest.

        Additional questions on evaluation.  # noqa: E501

        :param additional_questions: The additional_questions of this EvaluateOnFlyRequest.  # noqa: E501
        :type: list[QuestionAndAnswers]
        """

        self._additional_questions = additional_questions

    @property
    def candidate_additional_fields(self):
        """Gets the candidate_additional_fields of this EvaluateOnFlyRequest.  # noqa: E501

        Candidate additional fields.  # noqa: E501

        :return: The candidate_additional_fields of this EvaluateOnFlyRequest.  # noqa: E501
        :rtype: list[EvaluateOnFlyRequestCandidateAdditionalFields]
        """
        return self._candidate_additional_fields

    @candidate_additional_fields.setter
    def candidate_additional_fields(self, candidate_additional_fields):
        """Sets the candidate_additional_fields of this EvaluateOnFlyRequest.

        Candidate additional fields.  # noqa: E501

        :param candidate_additional_fields: The candidate_additional_fields of this EvaluateOnFlyRequest.  # noqa: E501
        :type: list[EvaluateOnFlyRequestCandidateAdditionalFields]
        """

        self._candidate_additional_fields = candidate_additional_fields

    @property
    def form_id(self):
        """Gets the form_id of this EvaluateOnFlyRequest.  # noqa: E501

        Id of evaluation form.  # noqa: E501

        :return: The form_id of this EvaluateOnFlyRequest.  # noqa: E501
        :rtype: str
        """
        return self._form_id

    @form_id.setter
    def form_id(self, form_id):
        """Sets the form_id of this EvaluateOnFlyRequest.

        Id of evaluation form.  # noqa: E501

        :param form_id: The form_id of this EvaluateOnFlyRequest.  # noqa: E501
        :type: str
        """

        self._form_id = form_id

    @property
    def form_name(self):
        """Gets the form_name of this EvaluateOnFlyRequest.  # noqa: E501

        Name of evaluation form.  # noqa: E501

        :return: The form_name of this EvaluateOnFlyRequest.  # noqa: E501
        :rtype: str
        """
        return self._form_name

    @form_name.setter
    def form_name(self, form_name):
        """Sets the form_name of this EvaluateOnFlyRequest.

        Name of evaluation form.  # noqa: E501

        :param form_name: The form_name of this EvaluateOnFlyRequest.  # noqa: E501
        :type: str
        """

        self._form_name = form_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EvaluateOnFlyRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EvaluateOnFlyRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
