# coding: utf-8

"""
    hrm-api

    Hiring Manager can view all the pending tasks and evaluate the interview if any pending interviews.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class BadRequest(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'message': 'str',
        'status': 'str',
        'error': 'str',
        'literal_id': 'str'
    }

    attribute_map = {
        'message': 'message',
        'status': 'status',
        'error': 'error',
        'literal_id': 'literalId'
    }

    def __init__(self, message='Bad Request: Missing required parameter', status='failure', error='INVALID_REQUEST_DATA', literal_id='hrm-ui-missing-required-parameters'):  # noqa: E501
        """BadRequest - a model defined in Swagger"""  # noqa: E501
        self._message = None
        self._status = None
        self._error = None
        self._literal_id = None
        self.discriminator = None
        if message is not None:
            self.message = message
        if status is not None:
            self.status = status
        if error is not None:
            self.error = error
        if literal_id is not None:
            self.literal_id = literal_id

    @property
    def message(self):
        """Gets the message of this BadRequest.  # noqa: E501

        Error message of the request.  # noqa: E501

        :return: The message of this BadRequest.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this BadRequest.

        Error message of the request.  # noqa: E501

        :param message: The message of this BadRequest.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def status(self):
        """Gets the status of this BadRequest.  # noqa: E501

        Success or failure status of the request.  # noqa: E501

        :return: The status of this BadRequest.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this BadRequest.

        Success or failure status of the request.  # noqa: E501

        :param status: The status of this BadRequest.  # noqa: E501
        :type: str
        """

        self._status = status

    @property
    def error(self):
        """Gets the error of this BadRequest.  # noqa: E501

        Error of the request.  # noqa: E501

        :return: The error of this BadRequest.  # noqa: E501
        :rtype: str
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this BadRequest.

        Error of the request.  # noqa: E501

        :param error: The error of this BadRequest.  # noqa: E501
        :type: str
        """

        self._error = error

    @property
    def literal_id(self):
        """Gets the literal_id of this BadRequest.  # noqa: E501

        Literal ID of the request.  # noqa: E501

        :return: The literal_id of this BadRequest.  # noqa: E501
        :rtype: str
        """
        return self._literal_id

    @literal_id.setter
    def literal_id(self, literal_id):
        """Sets the literal_id of this BadRequest.

        Literal ID of the request.  # noqa: E501

        :param literal_id: The literal_id of this BadRequest.  # noqa: E501
        :type: str
        """

        self._literal_id = literal_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(BadRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BadRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
