# coding: utf-8

"""
    jobs-questionnarie-api

    These APIs streamline question management, providing tools to create, delete, and update questions. Additionally, they offer functionality to attach question lists to specific job profiles.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class CreateJobQuestionnarieRequest(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'questionnaire_name': 'str',
        'job_category': 'str',
        'template_type': 'str',
        'pre_screening_questions': 'list[CreateJobQuestionnarieRequestPreScreeningQuestions]',
        'template_id': 'str',
        'as_custom': 'bool'
    }

    attribute_map = {
        'questionnaire_name': 'questionnaireName',
        'job_category': 'jobCategory',
        'template_type': 'templateType',
        'pre_screening_questions': 'preScreeningQuestions',
        'template_id': 'templateId',
        'as_custom': 'asCustom'
    }

    def __init__(self, questionnaire_name=None, job_category=None, template_type=None, pre_screening_questions=None, template_id=None, as_custom=None):  # noqa: E501
        """CreateJobQuestionnarieRequest - a model defined in Swagger"""  # noqa: E501
        self._questionnaire_name = None
        self._job_category = None
        self._template_type = None
        self._pre_screening_questions = None
        self._template_id = None
        self._as_custom = None
        self.discriminator = None
        self.questionnaire_name = questionnaire_name
        self.job_category = job_category
        self.template_type = template_type
        self.pre_screening_questions = pre_screening_questions
        self.template_id = template_id
        self.as_custom = as_custom

    @property
    def questionnaire_name(self):
        """Gets the questionnaire_name of this CreateJobQuestionnarieRequest.  # noqa: E501

        The name of the job questionnaire.  # noqa: E501

        :return: The questionnaire_name of this CreateJobQuestionnarieRequest.  # noqa: E501
        :rtype: str
        """
        return self._questionnaire_name

    @questionnaire_name.setter
    def questionnaire_name(self, questionnaire_name):
        """Sets the questionnaire_name of this CreateJobQuestionnarieRequest.

        The name of the job questionnaire.  # noqa: E501

        :param questionnaire_name: The questionnaire_name of this CreateJobQuestionnarieRequest.  # noqa: E501
        :type: str
        """
        if questionnaire_name is None:
            raise ValueError("Invalid value for `questionnaire_name`, must not be `None`")  # noqa: E501

        self._questionnaire_name = questionnaire_name

    @property
    def job_category(self):
        """Gets the job_category of this CreateJobQuestionnarieRequest.  # noqa: E501

        The category of the job associated with the questionnaire.  # noqa: E501

        :return: The job_category of this CreateJobQuestionnarieRequest.  # noqa: E501
        :rtype: str
        """
        return self._job_category

    @job_category.setter
    def job_category(self, job_category):
        """Sets the job_category of this CreateJobQuestionnarieRequest.

        The category of the job associated with the questionnaire.  # noqa: E501

        :param job_category: The job_category of this CreateJobQuestionnarieRequest.  # noqa: E501
        :type: str
        """
        if job_category is None:
            raise ValueError("Invalid value for `job_category`, must not be `None`")  # noqa: E501

        self._job_category = job_category

    @property
    def template_type(self):
        """Gets the template_type of this CreateJobQuestionnarieRequest.  # noqa: E501

        The type of template for the questionnaire.  # noqa: E501

        :return: The template_type of this CreateJobQuestionnarieRequest.  # noqa: E501
        :rtype: str
        """
        return self._template_type

    @template_type.setter
    def template_type(self, template_type):
        """Sets the template_type of this CreateJobQuestionnarieRequest.

        The type of template for the questionnaire.  # noqa: E501

        :param template_type: The template_type of this CreateJobQuestionnarieRequest.  # noqa: E501
        :type: str
        """
        if template_type is None:
            raise ValueError("Invalid value for `template_type`, must not be `None`")  # noqa: E501

        self._template_type = template_type

    @property
    def pre_screening_questions(self):
        """Gets the pre_screening_questions of this CreateJobQuestionnarieRequest.  # noqa: E501


        :return: The pre_screening_questions of this CreateJobQuestionnarieRequest.  # noqa: E501
        :rtype: list[CreateJobQuestionnarieRequestPreScreeningQuestions]
        """
        return self._pre_screening_questions

    @pre_screening_questions.setter
    def pre_screening_questions(self, pre_screening_questions):
        """Sets the pre_screening_questions of this CreateJobQuestionnarieRequest.


        :param pre_screening_questions: The pre_screening_questions of this CreateJobQuestionnarieRequest.  # noqa: E501
        :type: list[CreateJobQuestionnarieRequestPreScreeningQuestions]
        """
        if pre_screening_questions is None:
            raise ValueError("Invalid value for `pre_screening_questions`, must not be `None`")  # noqa: E501

        self._pre_screening_questions = pre_screening_questions

    @property
    def template_id(self):
        """Gets the template_id of this CreateJobQuestionnarieRequest.  # noqa: E501

        The ID of the template associated with the questionnaire.  # noqa: E501

        :return: The template_id of this CreateJobQuestionnarieRequest.  # noqa: E501
        :rtype: str
        """
        return self._template_id

    @template_id.setter
    def template_id(self, template_id):
        """Sets the template_id of this CreateJobQuestionnarieRequest.

        The ID of the template associated with the questionnaire.  # noqa: E501

        :param template_id: The template_id of this CreateJobQuestionnarieRequest.  # noqa: E501
        :type: str
        """
        if template_id is None:
            raise ValueError("Invalid value for `template_id`, must not be `None`")  # noqa: E501

        self._template_id = template_id

    @property
    def as_custom(self):
        """Gets the as_custom of this CreateJobQuestionnarieRequest.  # noqa: E501

        A boolean indicating whether the questionnaire is treated as custom.  # noqa: E501

        :return: The as_custom of this CreateJobQuestionnarieRequest.  # noqa: E501
        :rtype: bool
        """
        return self._as_custom

    @as_custom.setter
    def as_custom(self, as_custom):
        """Sets the as_custom of this CreateJobQuestionnarieRequest.

        A boolean indicating whether the questionnaire is treated as custom.  # noqa: E501

        :param as_custom: The as_custom of this CreateJobQuestionnarieRequest.  # noqa: E501
        :type: bool
        """
        if as_custom is None:
            raise ValueError("Invalid value for `as_custom`, must not be `None`")  # noqa: E501

        self._as_custom = as_custom

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CreateJobQuestionnarieRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateJobQuestionnarieRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
