# coding: utf-8

"""
    projects-api

    These APIs allows you to create workflow statuses, which are then assigned to workflows. These workflows, containing multiple statuses, are subsequently linked to projects. Additionally, candidates are associated with projects, defining the path they are meant to follow within the established workflows.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class GetProjectsResponseCandidateInfos(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'user_id': 'str',
        'parent_id': 'str'
    }

    attribute_map = {
        'user_id': 'userId',
        'parent_id': 'parentId'
    }

    def __init__(self, user_id=None, parent_id=None):  # noqa: E501
        """GetProjectsResponseCandidateInfos - a model defined in Swagger"""  # noqa: E501
        self._user_id = None
        self._parent_id = None
        self.discriminator = None
        self.user_id = user_id
        self.parent_id = parent_id

    @property
    def user_id(self):
        """Gets the user_id of this GetProjectsResponseCandidateInfos.  # noqa: E501

        The unique identifier for a candidate in the project.  # noqa: E501

        :return: The user_id of this GetProjectsResponseCandidateInfos.  # noqa: E501
        :rtype: str
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """Sets the user_id of this GetProjectsResponseCandidateInfos.

        The unique identifier for a candidate in the project.  # noqa: E501

        :param user_id: The user_id of this GetProjectsResponseCandidateInfos.  # noqa: E501
        :type: str
        """
        if user_id is None:
            raise ValueError("Invalid value for `user_id`, must not be `None`")  # noqa: E501

        self._user_id = user_id

    @property
    def parent_id(self):
        """Gets the parent_id of this GetProjectsResponseCandidateInfos.  # noqa: E501

        The unique identifier for the parent of the candidate in the project.  # noqa: E501

        :return: The parent_id of this GetProjectsResponseCandidateInfos.  # noqa: E501
        :rtype: str
        """
        return self._parent_id

    @parent_id.setter
    def parent_id(self, parent_id):
        """Sets the parent_id of this GetProjectsResponseCandidateInfos.

        The unique identifier for the parent of the candidate in the project.  # noqa: E501

        :param parent_id: The parent_id of this GetProjectsResponseCandidateInfos.  # noqa: E501
        :type: str
        """
        if parent_id is None:
            raise ValueError("Invalid value for `parent_id`, must not be `None`")  # noqa: E501

        self._parent_id = parent_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetProjectsResponseCandidateInfos, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetProjectsResponseCandidateInfos):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
