# coding: utf-8

"""
    recommendations-api

    These APIs provide job suggestions based on your profile, akin job listings, and nearby job opportunities tailored to your qualifications.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class ProfileMatchingResponseLocationData(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'city': 'str',
        'state': 'str',
        'country': 'str',
        'postal_code': 'str',
        'location': 'str'
    }

    attribute_map = {
        'city': 'city',
        'state': 'state',
        'country': 'country',
        'postal_code': 'postalCode',
        'location': 'location'
    }

    def __init__(self, city=None, state=None, country=None, postal_code=None, location=None):  # noqa: E501
        """ProfileMatchingResponseLocationData - a model defined in Swagger"""  # noqa: E501
        self._city = None
        self._state = None
        self._country = None
        self._postal_code = None
        self._location = None
        self.discriminator = None
        if city is not None:
            self.city = city
        if state is not None:
            self.state = state
        if country is not None:
            self.country = country
        if postal_code is not None:
            self.postal_code = postal_code
        if location is not None:
            self.location = location

    @property
    def city(self):
        """Gets the city of this ProfileMatchingResponseLocationData.  # noqa: E501

        Primary city of the job's location.  # noqa: E501

        :return: The city of this ProfileMatchingResponseLocationData.  # noqa: E501
        :rtype: str
        """
        return self._city

    @city.setter
    def city(self, city):
        """Sets the city of this ProfileMatchingResponseLocationData.

        Primary city of the job's location.  # noqa: E501

        :param city: The city of this ProfileMatchingResponseLocationData.  # noqa: E501
        :type: str
        """

        self._city = city

    @property
    def state(self):
        """Gets the state of this ProfileMatchingResponseLocationData.  # noqa: E501

        Primary state of the job's location.  # noqa: E501

        :return: The state of this ProfileMatchingResponseLocationData.  # noqa: E501
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this ProfileMatchingResponseLocationData.

        Primary state of the job's location.  # noqa: E501

        :param state: The state of this ProfileMatchingResponseLocationData.  # noqa: E501
        :type: str
        """

        self._state = state

    @property
    def country(self):
        """Gets the country of this ProfileMatchingResponseLocationData.  # noqa: E501

        Primary country of the job's location.  # noqa: E501

        :return: The country of this ProfileMatchingResponseLocationData.  # noqa: E501
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country):
        """Sets the country of this ProfileMatchingResponseLocationData.

        Primary country of the job's location.  # noqa: E501

        :param country: The country of this ProfileMatchingResponseLocationData.  # noqa: E501
        :type: str
        """

        self._country = country

    @property
    def postal_code(self):
        """Gets the postal_code of this ProfileMatchingResponseLocationData.  # noqa: E501

        Zip code of the job's location.  # noqa: E501

        :return: The postal_code of this ProfileMatchingResponseLocationData.  # noqa: E501
        :rtype: str
        """
        return self._postal_code

    @postal_code.setter
    def postal_code(self, postal_code):
        """Sets the postal_code of this ProfileMatchingResponseLocationData.

        Zip code of the job's location.  # noqa: E501

        :param postal_code: The postal_code of this ProfileMatchingResponseLocationData.  # noqa: E501
        :type: str
        """

        self._postal_code = postal_code

    @property
    def location(self):
        """Gets the location of this ProfileMatchingResponseLocationData.  # noqa: E501

        Primary location of the job.  # noqa: E501

        :return: The location of this ProfileMatchingResponseLocationData.  # noqa: E501
        :rtype: str
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this ProfileMatchingResponseLocationData.

        Primary location of the job.  # noqa: E501

        :param location: The location of this ProfileMatchingResponseLocationData.  # noqa: E501
        :type: str
        """

        self._location = location

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ProfileMatchingResponseLocationData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProfileMatchingResponseLocationData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
