# coding: utf-8

"""
    servicehub-public-api

    Public APIs for managing user data.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class SearchRequestProduct(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'product_title': 'str',
        'roles': 'list[str]'
    }

    attribute_map = {
        'product_title': 'productTitle',
        'roles': 'roles'
    }

    def __init__(self, product_title=None, roles=None):  # noqa: E501
        """SearchRequestProduct - a model defined in Swagger"""  # noqa: E501
        self._product_title = None
        self._roles = None
        self.discriminator = None
        if product_title is not None:
            self.product_title = product_title
        if roles is not None:
            self.roles = roles

    @property
    def product_title(self):
        """Gets the product_title of this SearchRequestProduct.  # noqa: E501

        Title of the product associated with the user.  # noqa: E501

        :return: The product_title of this SearchRequestProduct.  # noqa: E501
        :rtype: str
        """
        return self._product_title

    @product_title.setter
    def product_title(self, product_title):
        """Sets the product_title of this SearchRequestProduct.

        Title of the product associated with the user.  # noqa: E501

        :param product_title: The product_title of this SearchRequestProduct.  # noqa: E501
        :type: str
        """

        self._product_title = product_title

    @property
    def roles(self):
        """Gets the roles of this SearchRequestProduct.  # noqa: E501

        List of roles associated with the product.  # noqa: E501

        :return: The roles of this SearchRequestProduct.  # noqa: E501
        :rtype: list[str]
        """
        return self._roles

    @roles.setter
    def roles(self, roles):
        """Sets the roles of this SearchRequestProduct.

        List of roles associated with the product.  # noqa: E501

        :param roles: The roles of this SearchRequestProduct.  # noqa: E501
        :type: list[str]
        """

        self._roles = roles

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SearchRequestProduct, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SearchRequestProduct):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
