# coding: utf-8

"""
    servicehub-scim-api

    API endpoints for user management, utilizing the SCIM protocol.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class ScimPatchRequest(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'schemas': 'list[str]',
        'operations': 'list[ScimPatchRequestOperations]'
    }

    attribute_map = {
        'schemas': 'schemas',
        'operations': 'operations'
    }

    def __init__(self, schemas=None, operations=None):  # noqa: E501
        """ScimPatchRequest - a model defined in Swagger"""  # noqa: E501
        self._schemas = None
        self._operations = None
        self.discriminator = None
        if schemas is not None:
            self.schemas = schemas
        if operations is not None:
            self.operations = operations

    @property
    def schemas(self):
        """Gets the schemas of this ScimPatchRequest.  # noqa: E501

        An array of strings indicating the available schemas for the resource.  # noqa: E501

        :return: The schemas of this ScimPatchRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._schemas

    @schemas.setter
    def schemas(self, schemas):
        """Sets the schemas of this ScimPatchRequest.

        An array of strings indicating the available schemas for the resource.  # noqa: E501

        :param schemas: The schemas of this ScimPatchRequest.  # noqa: E501
        :type: list[str]
        """

        self._schemas = schemas

    @property
    def operations(self):
        """Gets the operations of this ScimPatchRequest.  # noqa: E501

        List of patch operations.  # noqa: E501

        :return: The operations of this ScimPatchRequest.  # noqa: E501
        :rtype: list[ScimPatchRequestOperations]
        """
        return self._operations

    @operations.setter
    def operations(self, operations):
        """Sets the operations of this ScimPatchRequest.

        List of patch operations.  # noqa: E501

        :param operations: The operations of this ScimPatchRequest.  # noqa: E501
        :type: list[ScimPatchRequestOperations]
        """

        self._operations = operations

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScimPatchRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScimPatchRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
