# coding: utf-8

"""
    servicehub-scim-api

    API endpoints for user management, utilizing the SCIM protocol.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class ScimUserAddresses(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'str',
        'primary': 'bool',
        'formatted': 'str',
        'locality': 'str',
        'region': 'str'
    }

    attribute_map = {
        'type': 'type',
        'primary': 'primary',
        'formatted': 'formatted',
        'locality': 'locality',
        'region': 'region'
    }

    def __init__(self, type=None, primary=None, formatted=None, locality=None, region=None):  # noqa: E501
        """ScimUserAddresses - a model defined in Swagger"""  # noqa: E501
        self._type = None
        self._primary = None
        self._formatted = None
        self._locality = None
        self._region = None
        self.discriminator = None
        if type is not None:
            self.type = type
        if primary is not None:
            self.primary = primary
        if formatted is not None:
            self.formatted = formatted
        if locality is not None:
            self.locality = locality
        if region is not None:
            self.region = region

    @property
    def type(self):
        """Gets the type of this ScimUserAddresses.  # noqa: E501

        Type of address.  # noqa: E501

        :return: The type of this ScimUserAddresses.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ScimUserAddresses.

        Type of address.  # noqa: E501

        :param type: The type of this ScimUserAddresses.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def primary(self):
        """Gets the primary of this ScimUserAddresses.  # noqa: E501

        Indicates whether the address is the primary one.  # noqa: E501

        :return: The primary of this ScimUserAddresses.  # noqa: E501
        :rtype: bool
        """
        return self._primary

    @primary.setter
    def primary(self, primary):
        """Sets the primary of this ScimUserAddresses.

        Indicates whether the address is the primary one.  # noqa: E501

        :param primary: The primary of this ScimUserAddresses.  # noqa: E501
        :type: bool
        """

        self._primary = primary

    @property
    def formatted(self):
        """Gets the formatted of this ScimUserAddresses.  # noqa: E501

        Formatted address.  # noqa: E501

        :return: The formatted of this ScimUserAddresses.  # noqa: E501
        :rtype: str
        """
        return self._formatted

    @formatted.setter
    def formatted(self, formatted):
        """Sets the formatted of this ScimUserAddresses.

        Formatted address.  # noqa: E501

        :param formatted: The formatted of this ScimUserAddresses.  # noqa: E501
        :type: str
        """

        self._formatted = formatted

    @property
    def locality(self):
        """Gets the locality of this ScimUserAddresses.  # noqa: E501

        Locality or city of the address.  # noqa: E501

        :return: The locality of this ScimUserAddresses.  # noqa: E501
        :rtype: str
        """
        return self._locality

    @locality.setter
    def locality(self, locality):
        """Sets the locality of this ScimUserAddresses.

        Locality or city of the address.  # noqa: E501

        :param locality: The locality of this ScimUserAddresses.  # noqa: E501
        :type: str
        """

        self._locality = locality

    @property
    def region(self):
        """Gets the region of this ScimUserAddresses.  # noqa: E501

        Region or state of the address.  # noqa: E501

        :return: The region of this ScimUserAddresses.  # noqa: E501
        :rtype: str
        """
        return self._region

    @region.setter
    def region(self, region):
        """Sets the region of this ScimUserAddresses.

        Region or state of the address.  # noqa: E501

        :param region: The region of this ScimUserAddresses.  # noqa: E501
        :type: str
        """

        self._region = region

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScimUserAddresses, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScimUserAddresses):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
