# coding: utf-8

"""
    servicehub-scim-api

    API endpoints for user management, utilizing the SCIM protocol.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class ScimUserGroups(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'value': 'str',
        'display': 'str'
    }

    attribute_map = {
        'value': 'value',
        'display': 'display'
    }

    def __init__(self, value=None, display=None):  # noqa: E501
        """ScimUserGroups - a model defined in Swagger"""  # noqa: E501
        self._value = None
        self._display = None
        self.discriminator = None
        if value is not None:
            self.value = value
        if display is not None:
            self.display = display

    @property
    def value(self):
        """Gets the value of this ScimUserGroups.  # noqa: E501

        The unique refnum identifying the tenant.  # noqa: E501

        :return: The value of this ScimUserGroups.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this ScimUserGroups.

        The unique refnum identifying the tenant.  # noqa: E501

        :param value: The value of this ScimUserGroups.  # noqa: E501
        :type: str
        """

        self._value = value

    @property
    def display(self):
        """Gets the display of this ScimUserGroups.  # noqa: E501

        The name of the tenant.  # noqa: E501

        :return: The display of this ScimUserGroups.  # noqa: E501
        :rtype: str
        """
        return self._display

    @display.setter
    def display(self, display):
        """Sets the display of this ScimUserGroups.

        The name of the tenant.  # noqa: E501

        :param display: The display of this ScimUserGroups.  # noqa: E501
        :type: str
        """

        self._display = display

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScimUserGroups, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScimUserGroups):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
