# coding: utf-8

"""
    servicehub-scim-api

    API endpoints for user management, utilizing the SCIM protocol.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class ScimUserName(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'family_name': 'str',
        'given_name': 'str',
        'middle_name': 'str'
    }

    attribute_map = {
        'family_name': 'familyName',
        'given_name': 'givenName',
        'middle_name': 'middleName'
    }

    def __init__(self, family_name=None, given_name=None, middle_name=None):  # noqa: E501
        """ScimUserName - a model defined in Swagger"""  # noqa: E501
        self._family_name = None
        self._given_name = None
        self._middle_name = None
        self.discriminator = None
        if family_name is not None:
            self.family_name = family_name
        if given_name is not None:
            self.given_name = given_name
        if middle_name is not None:
            self.middle_name = middle_name

    @property
    def family_name(self):
        """Gets the family_name of this ScimUserName.  # noqa: E501

        User's family name.  # noqa: E501

        :return: The family_name of this ScimUserName.  # noqa: E501
        :rtype: str
        """
        return self._family_name

    @family_name.setter
    def family_name(self, family_name):
        """Sets the family_name of this ScimUserName.

        User's family name.  # noqa: E501

        :param family_name: The family_name of this ScimUserName.  # noqa: E501
        :type: str
        """

        self._family_name = family_name

    @property
    def given_name(self):
        """Gets the given_name of this ScimUserName.  # noqa: E501

        User's given name.  # noqa: E501

        :return: The given_name of this ScimUserName.  # noqa: E501
        :rtype: str
        """
        return self._given_name

    @given_name.setter
    def given_name(self, given_name):
        """Sets the given_name of this ScimUserName.

        User's given name.  # noqa: E501

        :param given_name: The given_name of this ScimUserName.  # noqa: E501
        :type: str
        """

        self._given_name = given_name

    @property
    def middle_name(self):
        """Gets the middle_name of this ScimUserName.  # noqa: E501

        User's middle name.  # noqa: E501

        :return: The middle_name of this ScimUserName.  # noqa: E501
        :rtype: str
        """
        return self._middle_name

    @middle_name.setter
    def middle_name(self, middle_name):
        """Sets the middle_name of this ScimUserName.

        User's middle name.  # noqa: E501

        :param middle_name: The middle_name of this ScimUserName.  # noqa: E501
        :type: str
        """

        self._middle_name = middle_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ScimUserName, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScimUserName):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
