# coding: utf-8

"""
    tags-api

    These APIs enable tag management for candidates, offering functionalities to create, update, delete tags, and add or remove them from candidate profiles.  # noqa: E501

    OpenAPI spec version: 1.0.3
    
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class GetTagsResponsePagination(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'total': 'int',
        'size': 'int',
        '_from': 'int'
    }

    attribute_map = {
        'total': 'total',
        'size': 'size',
        '_from': 'from'
    }

    def __init__(self, total=None, size=None, _from=None):  # noqa: E501
        """GetTagsResponsePagination - a model defined in Swagger"""  # noqa: E501
        self._total = None
        self._size = None
        self.__from = None
        self.discriminator = None
        self.total = total
        self.size = size
        self._from = _from

    @property
    def total(self):
        """Gets the total of this GetTagsResponsePagination.  # noqa: E501

        The total number of tags available.  # noqa: E501

        :return: The total of this GetTagsResponsePagination.  # noqa: E501
        :rtype: int
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this GetTagsResponsePagination.

        The total number of tags available.  # noqa: E501

        :param total: The total of this GetTagsResponsePagination.  # noqa: E501
        :type: int
        """
        if total is None:
            raise ValueError("Invalid value for `total`, must not be `None`")  # noqa: E501

        self._total = total

    @property
    def size(self):
        """Gets the size of this GetTagsResponsePagination.  # noqa: E501

        The number of tags in the current response.  # noqa: E501

        :return: The size of this GetTagsResponsePagination.  # noqa: E501
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this GetTagsResponsePagination.

        The number of tags in the current response.  # noqa: E501

        :param size: The size of this GetTagsResponsePagination.  # noqa: E501
        :type: int
        """
        if size is None:
            raise ValueError("Invalid value for `size`, must not be `None`")  # noqa: E501

        self._size = size

    @property
    def _from(self):
        """Gets the _from of this GetTagsResponsePagination.  # noqa: E501

        The index from which the tags are being retrieved.  # noqa: E501

        :return: The _from of this GetTagsResponsePagination.  # noqa: E501
        :rtype: int
        """
        return self.__from

    @_from.setter
    def _from(self, _from):
        """Sets the _from of this GetTagsResponsePagination.

        The index from which the tags are being retrieved.  # noqa: E501

        :param _from: The _from of this GetTagsResponsePagination.  # noqa: E501
        :type: int
        """
        if _from is None:
            raise ValueError("Invalid value for `_from`, must not be `None`")  # noqa: E501

        self.__from = _from

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetTagsResponsePagination, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetTagsResponsePagination):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
