# coding: utf-8

"""
    videoplatform-api

    Interview Screening APIs allows to invite candidate to interview, evaluate and review candidates interview performances.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@phenompeople.com
    Generated by: phenom
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from phenom.commons.api_client import ApiClient


class EvaluationsApi(object):
    base_path = "/interview-screening"  # your base path

    def __init__(self, token, gateway_url, apikey, api_client=None):
        if api_client is None:
            api_client = ApiClient(gateway_url + self.base_path, apikey, token)
        self.api_client = api_client

    def add_evaluation_to_video_assessment(self, body, recruiter_user_id, **kwargs):  # noqa: E501
        """Evaluate Interview  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_evaluation_to_video_assessment(body, recruiter_user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param GiveEvaluationRequest body: (required)
        :param str recruiter_user_id: (required)
        :return: GiveEvaluationResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_evaluation_to_video_assessment_with_http_info(body, recruiter_user_id, **kwargs)  # noqa: E501
        else:
            (data) = self.add_evaluation_to_video_assessment_with_http_info(body, recruiter_user_id, **kwargs)  # noqa: E501
            return data

    def add_evaluation_to_video_assessment_with_http_info(self, body, recruiter_user_id, **kwargs):  # noqa: E501
        """Evaluate Interview  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_evaluation_to_video_assessment_with_http_info(body, recruiter_user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param GiveEvaluationRequest body: (required)
        :param str recruiter_user_id: (required)
        :return: GiveEvaluationResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'recruiter_user_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_evaluation_to_video_assessment" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `add_evaluation_to_video_assessment`")  # noqa: E501
        # verify the required parameter 'recruiter_user_id' is set
        if ('recruiter_user_id' not in params or
                params['recruiter_user_id'] is None):
            raise ValueError("Missing the required parameter `recruiter_user_id` when calling `add_evaluation_to_video_assessment`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'recruiter_user_id' in params:
            header_params['recruiterUserId'] = params['recruiter_user_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/evaluations', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GiveEvaluationResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_all_evaluations_for_interview_id(self, interview_id, **kwargs):  # noqa: E501
        """Gets Evaluations By InterviewId  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_evaluations_for_interview_id(interview_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str interview_id: (required)
        :return: GetAllEvaluationsForInterviewId
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_all_evaluations_for_interview_id_with_http_info(interview_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_all_evaluations_for_interview_id_with_http_info(interview_id, **kwargs)  # noqa: E501
            return data

    def get_all_evaluations_for_interview_id_with_http_info(self, interview_id, **kwargs):  # noqa: E501
        """Gets Evaluations By InterviewId  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_evaluations_for_interview_id_with_http_info(interview_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str interview_id: (required)
        :return: GetAllEvaluationsForInterviewId
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['interview_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_all_evaluations_for_interview_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'interview_id' is set
        if ('interview_id' not in params or
                params['interview_id'] is None):
            raise ValueError("Missing the required parameter `interview_id` when calling `get_all_evaluations_for_interview_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'interview_id' in params:
            path_params['interviewId'] = params['interview_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/evaluations/interviews/{interviewId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetAllEvaluationsForInterviewId',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_all_evaluations_for_interview_id_and_recruiter_id(self, interview_id, recruiter_id, **kwargs):  # noqa: E501
        """Gets Evaluations By Ids  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_evaluations_for_interview_id_and_recruiter_id(interview_id, recruiter_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str interview_id: (required)
        :param str recruiter_id: (required)
        :return: GetEvaluationsByInterviewIdAndRecruiterIdResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_all_evaluations_for_interview_id_and_recruiter_id_with_http_info(interview_id, recruiter_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_all_evaluations_for_interview_id_and_recruiter_id_with_http_info(interview_id, recruiter_id, **kwargs)  # noqa: E501
            return data

    def get_all_evaluations_for_interview_id_and_recruiter_id_with_http_info(self, interview_id, recruiter_id, **kwargs):  # noqa: E501
        """Gets Evaluations By Ids  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_all_evaluations_for_interview_id_and_recruiter_id_with_http_info(interview_id, recruiter_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str interview_id: (required)
        :param str recruiter_id: (required)
        :return: GetEvaluationsByInterviewIdAndRecruiterIdResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['interview_id', 'recruiter_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_all_evaluations_for_interview_id_and_recruiter_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'interview_id' is set
        if ('interview_id' not in params or
                params['interview_id'] is None):
            raise ValueError("Missing the required parameter `interview_id` when calling `get_all_evaluations_for_interview_id_and_recruiter_id`")  # noqa: E501
        # verify the required parameter 'recruiter_id' is set
        if ('recruiter_id' not in params or
                params['recruiter_id'] is None):
            raise ValueError("Missing the required parameter `recruiter_id` when calling `get_all_evaluations_for_interview_id_and_recruiter_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'interview_id' in params:
            path_params['interviewId'] = params['interview_id']  # noqa: E501
        if 'recruiter_id' in params:
            path_params['recruiterId'] = params['recruiter_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/evaluations/interview/{interviewId}/{recruiterId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetEvaluationsByInterviewIdAndRecruiterIdResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_evaluation_to_video_assessment(self, body, recruiter_user_id, **kwargs):  # noqa: E501
        """Update Evaluation  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_evaluation_to_video_assessment(body, recruiter_user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param GiveEvaluationRequest body: (required)
        :param str recruiter_user_id: (required)
        :return: GiveEvaluationResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_evaluation_to_video_assessment_with_http_info(body, recruiter_user_id, **kwargs)  # noqa: E501
        else:
            (data) = self.update_evaluation_to_video_assessment_with_http_info(body, recruiter_user_id, **kwargs)  # noqa: E501
            return data

    def update_evaluation_to_video_assessment_with_http_info(self, body, recruiter_user_id, **kwargs):  # noqa: E501
        """Update Evaluation  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_evaluation_to_video_assessment_with_http_info(body, recruiter_user_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param GiveEvaluationRequest body: (required)
        :param str recruiter_user_id: (required)
        :return: GiveEvaluationResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'recruiter_user_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_evaluation_to_video_assessment" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_evaluation_to_video_assessment`")  # noqa: E501
        # verify the required parameter 'recruiter_user_id' is set
        if ('recruiter_user_id' not in params or
                params['recruiter_user_id'] is None):
            raise ValueError("Missing the required parameter `recruiter_user_id` when calling `update_evaluation_to_video_assessment`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'recruiter_user_id' in params:
            header_params['recruiterUserId'] = params['recruiter_user_id']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/evaluations', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GiveEvaluationResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
