# coding: utf-8

"""
    videoplatform-api

    Interview Screening APIs allows to invite candidate to interview, evaluate and review candidates interview performances.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@phenompeople.com
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class GetQuestionnaireDetailsResponseDataQuestions(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'question_id': 'str',
        'question_translations': 'list[GetQuestionnaireDetailsResponseDataQuestionTranslations]',
        'question_text': 'str',
        'type': 'str',
        'response_duration_limit_in_sec': 'float',
        'max_number_retakes': 'float',
        'date_created': 'int',
        'last_updated': 'int',
        'max_points': 'float',
        'settings': 'object',
        'options': 'object'
    }

    attribute_map = {
        'question_id': 'questionId',
        'question_translations': 'questionTranslations',
        'question_text': 'questionText',
        'type': 'type',
        'response_duration_limit_in_sec': 'responseDurationLimitInSec',
        'max_number_retakes': 'maxNumberRetakes',
        'date_created': 'dateCreated',
        'last_updated': 'lastUpdated',
        'max_points': 'maxPoints',
        'settings': 'settings',
        'options': 'options'
    }

    def __init__(self, question_id=None, question_translations=None, question_text=None, type=None, response_duration_limit_in_sec=None, max_number_retakes=None, date_created=None, last_updated=None, max_points=None, settings=None, options=None):  # noqa: E501
        """GetQuestionnaireDetailsResponseDataQuestions - a model defined in Swagger"""  # noqa: E501
        self._question_id = None
        self._question_translations = None
        self._question_text = None
        self._type = None
        self._response_duration_limit_in_sec = None
        self._max_number_retakes = None
        self._date_created = None
        self._last_updated = None
        self._max_points = None
        self._settings = None
        self._options = None
        self.discriminator = None
        self.question_id = question_id
        self.question_translations = question_translations
        self.question_text = question_text
        self.type = type
        if response_duration_limit_in_sec is not None:
            self.response_duration_limit_in_sec = response_duration_limit_in_sec
        if max_number_retakes is not None:
            self.max_number_retakes = max_number_retakes
        self.date_created = date_created
        self.last_updated = last_updated
        self.max_points = max_points
        if settings is not None:
            self.settings = settings
        if options is not None:
            self.options = options

    @property
    def question_id(self):
        """Gets the question_id of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501

        Unique question id.  # noqa: E501

        :return: The question_id of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :rtype: str
        """
        return self._question_id

    @question_id.setter
    def question_id(self, question_id):
        """Sets the question_id of this GetQuestionnaireDetailsResponseDataQuestions.

        Unique question id.  # noqa: E501

        :param question_id: The question_id of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :type: str
        """
        if question_id is None:
            raise ValueError("Invalid value for `question_id`, must not be `None`")  # noqa: E501

        self._question_id = question_id

    @property
    def question_translations(self):
        """Gets the question_translations of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501

        Contains all translations for the question.  # noqa: E501

        :return: The question_translations of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :rtype: list[GetQuestionnaireDetailsResponseDataQuestionTranslations]
        """
        return self._question_translations

    @question_translations.setter
    def question_translations(self, question_translations):
        """Sets the question_translations of this GetQuestionnaireDetailsResponseDataQuestions.

        Contains all translations for the question.  # noqa: E501

        :param question_translations: The question_translations of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :type: list[GetQuestionnaireDetailsResponseDataQuestionTranslations]
        """
        if question_translations is None:
            raise ValueError("Invalid value for `question_translations`, must not be `None`")  # noqa: E501

        self._question_translations = question_translations

    @property
    def question_text(self):
        """Gets the question_text of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501

        Question text for the question.  # noqa: E501

        :return: The question_text of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :rtype: str
        """
        return self._question_text

    @question_text.setter
    def question_text(self, question_text):
        """Sets the question_text of this GetQuestionnaireDetailsResponseDataQuestions.

        Question text for the question.  # noqa: E501

        :param question_text: The question_text of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :type: str
        """
        if question_text is None:
            raise ValueError("Invalid value for `question_text`, must not be `None`")  # noqa: E501

        self._question_text = question_text

    @property
    def type(self):
        """Gets the type of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501

        Question type for the question. Can be video, audio, etc.  # noqa: E501

        :return: The type of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this GetQuestionnaireDetailsResponseDataQuestions.

        Question type for the question. Can be video, audio, etc.  # noqa: E501

        :param type: The type of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def response_duration_limit_in_sec(self):
        """Gets the response_duration_limit_in_sec of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501

        Question maximum recording duration allowed.  # noqa: E501

        :return: The response_duration_limit_in_sec of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :rtype: float
        """
        return self._response_duration_limit_in_sec

    @response_duration_limit_in_sec.setter
    def response_duration_limit_in_sec(self, response_duration_limit_in_sec):
        """Sets the response_duration_limit_in_sec of this GetQuestionnaireDetailsResponseDataQuestions.

        Question maximum recording duration allowed.  # noqa: E501

        :param response_duration_limit_in_sec: The response_duration_limit_in_sec of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :type: float
        """

        self._response_duration_limit_in_sec = response_duration_limit_in_sec

    @property
    def max_number_retakes(self):
        """Gets the max_number_retakes of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501

        Max retakes allowed for the question.  # noqa: E501

        :return: The max_number_retakes of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :rtype: float
        """
        return self._max_number_retakes

    @max_number_retakes.setter
    def max_number_retakes(self, max_number_retakes):
        """Sets the max_number_retakes of this GetQuestionnaireDetailsResponseDataQuestions.

        Max retakes allowed for the question.  # noqa: E501

        :param max_number_retakes: The max_number_retakes of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :type: float
        """

        self._max_number_retakes = max_number_retakes

    @property
    def date_created(self):
        """Gets the date_created of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501

        Date when question is created.  # noqa: E501

        :return: The date_created of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :rtype: int
        """
        return self._date_created

    @date_created.setter
    def date_created(self, date_created):
        """Sets the date_created of this GetQuestionnaireDetailsResponseDataQuestions.

        Date when question is created.  # noqa: E501

        :param date_created: The date_created of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :type: int
        """
        if date_created is None:
            raise ValueError("Invalid value for `date_created`, must not be `None`")  # noqa: E501

        self._date_created = date_created

    @property
    def last_updated(self):
        """Gets the last_updated of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501

        Date when question is updated.  # noqa: E501

        :return: The last_updated of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :rtype: int
        """
        return self._last_updated

    @last_updated.setter
    def last_updated(self, last_updated):
        """Sets the last_updated of this GetQuestionnaireDetailsResponseDataQuestions.

        Date when question is updated.  # noqa: E501

        :param last_updated: The last_updated of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :type: int
        """
        if last_updated is None:
            raise ValueError("Invalid value for `last_updated`, must not be `None`")  # noqa: E501

        self._last_updated = last_updated

    @property
    def max_points(self):
        """Gets the max_points of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501

        Date when question is updated.  # noqa: E501

        :return: The max_points of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :rtype: float
        """
        return self._max_points

    @max_points.setter
    def max_points(self, max_points):
        """Sets the max_points of this GetQuestionnaireDetailsResponseDataQuestions.

        Date when question is updated.  # noqa: E501

        :param max_points: The max_points of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :type: float
        """
        if max_points is None:
            raise ValueError("Invalid value for `max_points`, must not be `None`")  # noqa: E501

        self._max_points = max_points

    @property
    def settings(self):
        """Gets the settings of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501

        This object is dynamic, based on the question type.  # noqa: E501

        :return: The settings of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :rtype: object
        """
        return self._settings

    @settings.setter
    def settings(self, settings):
        """Sets the settings of this GetQuestionnaireDetailsResponseDataQuestions.

        This object is dynamic, based on the question type.  # noqa: E501

        :param settings: The settings of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :type: object
        """

        self._settings = settings

    @property
    def options(self):
        """Gets the options of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501

        This object is applicable only for particular question types.  # noqa: E501

        :return: The options of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :rtype: object
        """
        return self._options

    @options.setter
    def options(self, options):
        """Sets the options of this GetQuestionnaireDetailsResponseDataQuestions.

        This object is applicable only for particular question types.  # noqa: E501

        :param options: The options of this GetQuestionnaireDetailsResponseDataQuestions.  # noqa: E501
        :type: object
        """

        self._options = options

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetQuestionnaireDetailsResponseDataQuestions, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetQuestionnaireDetailsResponseDataQuestions):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
