# coding: utf-8

"""
    videoplatform-api

    Interview Screening APIs allows to invite candidate to interview, evaluate and review candidates interview performances.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@phenompeople.com
    Generated by: phenom
"""

import pprint
import re  # noqa: F401

import six

class InviteCandidate(object):
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'candidate_ids': 'list[str]',
        'entity_type': 'str',
        'entity_value': 'str'
    }

    attribute_map = {
        'candidate_ids': 'candidateIds',
        'entity_type': 'entityType',
        'entity_value': 'entityValue'
    }

    def __init__(self, candidate_ids=None, entity_type=None, entity_value=None):  # noqa: E501
        """InviteCandidate - a model defined in Swagger"""  # noqa: E501
        self._candidate_ids = None
        self._entity_type = None
        self._entity_value = None
        self.discriminator = None
        self.candidate_ids = candidate_ids
        self.entity_type = entity_type
        self.entity_value = entity_value

    @property
    def candidate_ids(self):
        """Gets the candidate_ids of this InviteCandidate.  # noqa: E501

        Candidate ids to be invited.  # noqa: E501

        :return: The candidate_ids of this InviteCandidate.  # noqa: E501
        :rtype: list[str]
        """
        return self._candidate_ids

    @candidate_ids.setter
    def candidate_ids(self, candidate_ids):
        """Sets the candidate_ids of this InviteCandidate.

        Candidate ids to be invited.  # noqa: E501

        :param candidate_ids: The candidate_ids of this InviteCandidate.  # noqa: E501
        :type: list[str]
        """
        if candidate_ids is None:
            raise ValueError("Invalid value for `candidate_ids`, must not be `None`")  # noqa: E501

        self._candidate_ids = candidate_ids

    @property
    def entity_type(self):
        """Gets the entity_type of this InviteCandidate.  # noqa: E501

        Can be job or event.  # noqa: E501

        :return: The entity_type of this InviteCandidate.  # noqa: E501
        :rtype: str
        """
        return self._entity_type

    @entity_type.setter
    def entity_type(self, entity_type):
        """Sets the entity_type of this InviteCandidate.

        Can be job or event.  # noqa: E501

        :param entity_type: The entity_type of this InviteCandidate.  # noqa: E501
        :type: str
        """
        if entity_type is None:
            raise ValueError("Invalid value for `entity_type`, must not be `None`")  # noqa: E501

        self._entity_type = entity_type

    @property
    def entity_value(self):
        """Gets the entity_value of this InviteCandidate.  # noqa: E501

        Job id for Job, eventScheduleId for event type.  # noqa: E501

        :return: The entity_value of this InviteCandidate.  # noqa: E501
        :rtype: str
        """
        return self._entity_value

    @entity_value.setter
    def entity_value(self, entity_value):
        """Sets the entity_value of this InviteCandidate.

        Job id for Job, eventScheduleId for event type.  # noqa: E501

        :param entity_value: The entity_value of this InviteCandidate.  # noqa: E501
        :type: str
        """
        if entity_value is None:
            raise ValueError("Invalid value for `entity_value`, must not be `None`")  # noqa: E501

        self._entity_value = entity_value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InviteCandidate, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InviteCandidate):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
