# coding: utf-8

"""
    videoplatform-api

    Interview Screening APIs allows to invite candidate to interview, evaluate and review candidates interview performances.  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@phenompeople.com
    Generated by: phenom
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from phenom.commons.api_client import ApiClient


class ReviewApi(object):
    base_path = "/interview-screening"  # your base path

    def __init__(self, token, gateway_url, apikey, api_client=None):
        if api_client is None:
            api_client = ApiClient(gateway_url + self.base_path, apikey, token)
        self.api_client = api_client

    def get_review_details_for_giving_evaluation(self, interview_id, **kwargs):  # noqa: E501
        """Get Details For Evaluating  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_review_details_for_giving_evaluation(interview_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str interview_id: (required)
        :return: GetInterviewDetailsForEvaluatingResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_review_details_for_giving_evaluation_with_http_info(interview_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_review_details_for_giving_evaluation_with_http_info(interview_id, **kwargs)  # noqa: E501
            return data

    def get_review_details_for_giving_evaluation_with_http_info(self, interview_id, **kwargs):  # noqa: E501
        """Get Details For Evaluating  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_review_details_for_giving_evaluation_with_http_info(interview_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str interview_id: (required)
        :return: GetInterviewDetailsForEvaluatingResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['interview_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_review_details_for_giving_evaluation" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'interview_id' is set
        if ('interview_id' not in params or
                params['interview_id'] is None):
            raise ValueError("Missing the required parameter `interview_id` when calling `get_review_details_for_giving_evaluation`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'interview_id' in params:
            path_params['interviewId'] = params['interview_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/v1/review/{interviewId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetInterviewDetailsForEvaluatingResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
